﻿#SingleInstance Force
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 작성자 : DDART
;; 배포장소 : DDART AUTOMATION
;; https://auto.ddart.net
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
global _app := new CAutocoderApplication("giftcard_autocoder", "2.64", "상품권번호 자동입력기 v2.64 (2020.11.01)")
return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main program
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CAutocoderApplication extends CApplication
{
	AddHotKey()
	{
		this.hotkeys["F1"] := this.ID_HELP_HELP
		this.hotkeys["F3"] := this.ID_EDIT_PREV
		this.hotkeys["F4"] := this.ID_EDIT_NEXT
		this.hotkeys["F5"] := this.ID_OPTION_SETTING
		this.hotkeys["F7"] := this.ID_TOOL_EXECUTE
		this.hotkeys["F8"] := this.ID_TOOL_STOP
		this.hotkeys["F9"] := this.ID_VIEW_STATS
		this.hotkeys["^l"] := this.ID_VIEW_LOG
		this.hotkeys["^m"] := this.ID_FILE_MAKEEXE
		this.hotkeys["^o"] := this.ID_FILE_OPEN
		this.hotkeys["^!s"] := this.ID_FILE_SAVEAS
		this.hotkeys["^e"] := this.ID_EDIT_ERASE
		this.hotkeys["^f"] := this.ID_EDIT_FETCH
		fn := this.OnHotKey.Bind(this)
		for key, val in % this.hotkeys
		{
			HotKey, %key%, %fn%
		}
	}
	AddGiftCode(name, code)
	{
		this.CreateGiftTab(name)
		view := this.tabContent.Select(name)
		view.Add("Select", A_Now, code, 0)			
	}
	AddMenu()
	{
		this.menu.file := new CMenu("File")
		this.ID_FILE_OPEN := this.menu.file.Add("열기(&O)`tCtrl+O")
		this.ID_FILE_SAVEAS := this.menu.file.Add("다른 이름으로 저장(&S)`tCtrl+Shift+S")
		this.ID_FILE_MAKEEXE := this.menu.file.Add("실행파일 만들기(&M)`tCtrl+M")
		this.ID_FILE_EXIT := this.menu.file.Add("종료(&X)")
		
		this.menu.option := new CMenu("Option")
		this.ID_OPTION_SETTING := this.menu.option.Add("설정(&S)`tF5")
		
		this.menu.edit := new CMenu("Edit")
		this.ID_EDIT_FETCH := this.menu.edit.Add("가져오기(&F)`tCtrl+F")
		this.ID_EDIT_PASTE := this.menu.edit.Add("붙여넣기(&P)")
		this.ID_EDIT_ERASE := this.menu.edit.Add("지우기(&E)`tCtrl+E")
		this.menu.view := new CMenu("View")
		this.ID_VIEW_LOG := this.menu.view.Add("로그창(&L)`tCtrl+L") 
		this.ID_VIEW_STATS := this.menu.view.Add("통계(&S)`tF9") 
		this.menu.tool := new CMenu("Tool")
		this.ID_TOOL_EXECUTE := this.menu.tool.Add("실행(&R)`tF7") 
		this.ID_TOOL_STOP := this.menu.tool.Add("중지(&S)`tF8") 
		this.ID_TOOL_PREV := this.menu.tool.Add("이전 페이지(&P)`tF3") 
		this.ID_TOOL_NEXT := this.menu.tool.Add("다음 페이지(&N)`tF4") 
		this.ID_TOOL_CHROMELAUNCH := this.menu.tool.Add("개발자모드 브라우저(&C)")
		this.menu.help := new CMenu("Help")
		this.ID_HELP_HELP := this.menu.help.Add("도움말(&H)`tF1")
		this.ID_HELP_UPDATE := this.menu.help.Add("업데이트 확인(&U)")
		this.menu.bar := new CMenu("MenuBar")
		this.menu.bar.Add("파일(&F)", this.menu.file)
		this.menu.bar.Add("편집(&E)", this.menu.edit)
		this.menu.bar.Add("보기(&V)", this.menu.view)
		this.menu.bar.Add("도구(&T)", this.menu.tool)
		this.menu.bar.Add("옵션(&O)", this.menu.option)
		this.menu.bar.Add("도움말(&H)", this.menu.help)
		Gui, Menu, % this.menu.bar.name
		this.menu.context := new CMenu("Context")
		this.ID_CONTEXT_EXECUTE := this.menu.context.Add("실 행`tF7 or Enter")
		this.ID_CONTEXT_SETUSED := this.menu.context.Add("사용함으로 표시")
		this.ID_CONTEXT_SETUNUSED := this.menu.context.Add("사용안함으로 표시")
		this.ID_CONTEXT_COPY := this.menu.context.Add("핀번호만 복사`tCtrl+C")
		this.ID_CONTEXT_COPYCONTENT := this.menu.context.Add("내용 복사")
		this.ID_CONTEXT_SELECTALL := this.menu.context.Add("전체선택`tCtrl+A")
		this.menu.context.Add("")
		this.ID_CONTEXT_DELETE := this.menu.context.Add("삭 제`tDelete")
		this.ID_CONTEXT_DELETEALL := this.menu.context.Add("전체삭제")
		
	}
	AddToolbar()
	{
		buttons := Array()
		icons := Array()
		if (A_OSVersion = "WIN_7")
		{
			icons := [137, 118, 140, 25, 200, 199, 156, 107]
		}
		else if (InStr(A_OSVersion, "WIN_8"))
		{
			icons := [123, 105, 127, 18, 187, 186, 143, 94]
		}
		else if (this.GetWin10Version() >= 1803)
		{
			icons := [122, 103, 125, 18, 154, 153, 136, 92]
		}
		else
		{
			icons := [120, 101, 123, 18, 183, 182, 139, 90]
		}
		buttons.Push(new CToolbarButton(this.ID_EDIT_FETCH, "가져오기", icons[1]))
		buttons.Push(new CToolbarButton(this.ID_EDIT_PASTE, "붙여넣기", icons[2]))
		buttons.Push(new CToolbarButton(this.ID_EDIT_ERASE, "지우기", icons[3]))
		buttons.Push(new CToolbarButton(this.ID_OPTION_SETTING, "설 정", icons[4]))
		buttons.Push(new CToolbarButton(this.ID_TOOL_PREV, "이 전", icons[5]))
		buttons.Push(new CToolbarButton(this.ID_TOOL_NEXT, "다 음", icons[6]))
		buttons.Push(new CToolbarButton(this.ID_TOOL_STOP, "중 지", icons[7]))
		buttons.Push(new CToolbarButton(this.ID_TOOL_EXECUTE, "실 행", icons[8]))
		
		il := IL_Create(buttons.MaxIndex(), 2, true)
		Loop, % buttons.MaxIndex()
		{
			IL_Add(il, buttons[A_Index].icofile, buttons[A_Index].icono)
		}
		this.toolbar.SetImageList(il)
		this.toolbar.SetButtonWidth(80 * this.m, 100 * this.m) 
		Loop, % buttons.MaxIndex()
		{
			this.toolbar.AddButton(A_Index -1, buttons[A_Index].id, buttons[A_Index].text)
		}
		this.toolbar.AutoSize()
		this.toolbar.SetMaxTextRows(1)
	}
	AppendContent(txt)
	{
		this.editContent.AppendText(txt "`r`n")
	}
	CreateGiftCard(ByRef content)
	{
		this.ReleaseGiftCard()
		if (InStr(content, "해피머니"))
		{
			this.giftcard := this.setting.browser ? new CHappyMoneyCR() : new CHappyMoneyIE()
		}
		if (InStr(content, "북앤라이프") || InStr(content, "도서문화"))
		{
			if (this.giftcard)
			{
				this.AppendLog("한번에 한 종류의 상품권만 추출이 가능합니다")
				return false
			}
			this.giftcard := this.setting.browser ? new CBookNLifeCR() : new CBookNLifeIE()
		}
		if (InStr(content, "컬쳐랜드"))
		{
			if (this.giftcard)
			{
				this.AppendLog("한번에 한 종류의 상품권만 추출이 가능합니다")
				return false
			}
			this.giftcard := this.setting.browser ? new CCultureLandCR() : new CCultureLandIE()
		}
		if (InStr(content, "스마일캐시"))
		{
			if (this.giftcard)
			{
				this.AppendLog("한번에 한 종류의 상품권만 추출이 가능합니다")
				return false
			}
			this.giftcard := new CSmileCash()
		}
		if (InStr(content, "금융상품권")  || InStr(content, "한국투자증권"))
		{
			if (this.giftcard)
			{
				this.AppendLog("한번에 한 종류의 상품권만 추출이 가능합니다")
				return false
			}
			this.giftcard := new CTrueFriend()
		}
		if (!this.giftcard)
		{
			this.AppendLog("상품권 종류를 알 수 없습니다. 핀번호외에 상품권 이름도 내용에 들어가야합니다.")
			return false
		}
		return true
	}
	CreateGiftTab(name)
	{
		if (this.tabContent.Exist(name))
		{
			return
		}
		this.tabContent.Add(new CGiftcodeView(name))
		timer := this.fnResizeOnce
		SetTimer, % timer, Off
		SetTimer, % timer, On
	}
	DeleteGiftCard()
	{
		critical, On
		if (this.giftcard)
		{
			this.giftcard := ""
			this.AppendLog("상품권 실행정보가 초기화되었습니다")
		}
		critical, Off
	}
	ExtractGiftCard()
	{
		content := this.editContent.ControlGetText()
		if (StrLen(content) > 1)
		{
			if (!this.CreateGiftCard(content))
			{
				return false
			}
			if (this.giftcard.Parse(content) && this.UpdateDatabases())
			{
				this.UpdateButtons()
				return true
			}
			this.AppendLog(this.giftcard.GetError())
			return false
		}
		this.AppendLog("상단에 내용을 입력하세요.")
		return false
	}
	InitApplication()
	{
		this.tabContent := new CTabCtrl()
		this.tabContent.Show()
		this.editContent := new CEditCtrl("상품권추출")
		this.editContent.Show()
		this.tabContent.Add(this.editContent)
		this.stats := new CStatisticsView("통계")
		this.tabLog.Add(this.stats)
		this.LoadGiftTabs()
	}
	LoadGiftTabs()
	{
		Loop, Files, db\* *.txt
		{
			StringTrimRight, name, A_LoopFileName, 4
			this.CreateGiftTab(name)
		}
	}
	LoadSetting()
	{
		this.setting := new CSetting()
		base.LoadSetting()
	}
	ReleaseGiftCard()
	{
		if (this.giftcard && this.giftcard.browser && this.giftcard.win.wb)
		{
			this.giftcard.win.wb.Disconnect()
			Loop, 100
			{
				if (!this.giftcard)
				{
					break
				}
				Sleep, 200
			}
		}
		this.giftcard := ""
	}
	ResizeOnce()
	{
		timer := this.fnResizeOnce
		SetTimer, % timer, Off
		w := this.w 
		h := this.h
		if (!w || !h)
		{
			return
		}
		this.setting.width := w
		this.setting.height := h
		margin := 0
		th := this.toolbar_h
		mh := h - th
		ct := margin + th
		cw := w - margin * 2
		ch := (this.bLogInit ? mh / 2 : mh) - margin
		lt := margin + th + (mh / 2)
		lw := cw
		lh := mh / 2 - margin
		;아래쪽 컨트롤부터 옮겨야 순간 겹쳐졌던 영역이 페인트 안되는 문제를 방지할수 있다.
		if (this.bLogInit)
		{
			this.tabLog.Move(margin, lt, lw, lh)
		}
		this.tabContent.Move(margin, ct, cw, ch)
		this.toolbar.Move(margin, margin, cw, th)
	}
	Run()
	{
		timer := this.fnRun
		SetTimer, %timer%, Off
		this.InitLog()
		if (this.tabContent.GetCurSel() = 0)
		{
			this.AppendLogBar("상품권추출 시작")
			if (this.ExtractGiftCard())
			{
				this.ReleaseGiftCard()
			}
			this.AppendLogBar("상품권추출 종료")
		}
		else
		{
			view := this.tabContent.GetCurChild()
			if (!this.giftcard || this.giftcard.view != view)
			{
				this.CreateGiftCard(view.name)
				view.bItemChanged := true
				this.giftcard.view := view
			}
			this.AppendLogBar(view.name)
			if (!this.giftcard.win.homepage_url)
			{
				this.AppendLog(this.giftcard.name " 상품권은 자동입력을 지원하지 않습니다")
			}
			else if (this.giftcard.Load() && this.giftcard.InitWebBrowser())
			{
				this.AppendLog(this.giftcard.GetBrowserInfo())
				this.AppendLog(this.giftcard.GetCurrentPageInfo())
				this.AppendLogBar("자동입력기 시작")
				if (!this.setting.send_mode)
				{
					SetKeyDelay, % this.setting.key_delay
				}
				if (this.giftcard.AutoInputEx())
				{
					this.AppendLogBar("자동입력기 완료")
					this.OnNext()
				}
				else
				{
					this.AppendLogBar("자동입력기 중단")
					this.AppendLog(this.giftcard.GetError())
				}
			}
			else
			{
				this.AppendLog(this.giftcard.GetError())
			}
		}
		this.ResetRunState()
	}
	SaveGiftCard()
	{
		Loop, % this.tabContent.children.Length()
		{
			if (A_Index != 1)
			{
				this.tabContent.children[A_Index].Save()
			}
		}
	}
	UpdateButtons()
	{
		base.UpdateButtons()
		this.EnableButton(this.menu.tool, this.ID_TOOL_PREV, !this.bRunning && this.bRunnable && this.giftcard && this.giftcard.GetName() =  this.tabContent.GetCurSelName() && this.giftcard.page != 1)
		this.EnableButton(this.menu.tool, this.ID_TOOL_NEXT, !this.bRunning && this.bRunnable && this.giftcard && this.giftcard.GetName() =  this.tabContent.GetCurSelName() && this.giftcard.page != this.giftcard.total_page)
	}
	UpdateDatabases()
	{
		name := this.giftcard.GetName()
		this.CreateGiftTab(name)
		view := this.tabContent.Select(name)
		view.SelectAll(false)
		Loop, % this.giftcard.codes.MaxIndex()
		{
			code := this.giftcard.GetCode(A_Index)
			if (view.Exist(2, code))
			{
				this.AppendLog(code " 는 이미 " name "탭에 존재하는 번호로 중복추출입니다.")
			}
			else
			{
				view.Add("Select", A_Now, code, 0)	
			}
		}
		view.EnsureVisible(view.GetCount() - 1)
		count := view.GetCount("S")
		this.AppendLog(name " : 총 " count "개의 신규 번호가 추출되었습니다.")
		if (count)
		{
			this.AppendLog("상품권이 선택된 상태에서 실행버튼을 다시 누르면 선택된 번호가 자동입력됩니다.")
			this.UpdateStatistics()
			return true
		}
		else
		{
			this.giftcard.err := "기존번호를 재실행하시려면 " name " 탭에서 마우스 드래그 혹은 Shift+클릭 혹은 Ctrl+클릭으로 멀티선택 후 실행하세요"
			return false
		}
	}
	UpdateStatistics()
	{
		this.stats.DeleteAll()
		Loop, % this.tabContent.children.Length()
		{
			if (A_Index != 1)
			{
				view := this.tabContent.children[A_Index]
				this.stats.Add("", "", view.name, view.stats*)
			}
		}
	}
	OnClose()
	{
		; comobj release
		if (this.giftcard)
		{
			this.DeleteGiftCard()
			this.OnFileExit()
			return true
		}
		this.SaveSetting()
		this.SaveGiftCard()
	}
	OnCommand(wParam, lParam, nMsg, hWnd)
	{
		id := wParam & 0xFFFF
		if (id = this.editContent.id )
		{
			notification_code := wParam >> 16
			EN_CHANGE := 0x0300
			if (notification_code = EN_CHANGE)
			{
				this.OnContentChanged(id)
			}
		}
		else if (id = this.editLog.id)
		{
		}
		else if (id = this.ID_EDIT_FETCH)
		{
			this.OnFetch()
		}
		else if (id = this.ID_EDIT_ERASE)
		{
			this.OnErase()
		}
		else if (id = this.ID_EDIT_PASTE)
		{
			this.OnPaste()
		}
		else if (id =  this.ID_OPTION_SETTING)
		{
			this.OnOptionSetting()
		}
		else if (id = this.ID_TOOL_PREV)
		{
			this.OnPrev()
		}
		else if (id = this.ID_TOOL_NEXT)
		{
			this.OnNext()
		}
		else if (id = this.ID_VIEW_LOG)
		{
			this.OnViewLog()
		}
		else if (id = this.ID_VIEW_STATS)
		{
			this.OnViewStats()
		}
		else if (id = this.ID_FILE_OPEN)
		{
			this.OnFileOpen()
		}
		else if (id = this.ID_FILE_SAVEAS)
		{
			this.OnFileSaveAs()
		}
		else if (id = this.ID_CONTEXT_EXECUTE)
		{
			this.OnExecute()
		}
		else if (id = this.ID_CONTEXT_COPY)
		{
			this.OnContextCopy()
		}
		else if (id = this.ID_CONTEXT_COPYCONTENT)
		{
			this.OnContextCopyContent()
		}
		else if (id = this.ID_CONTEXT_DELETE)
		{
			this.OnContextDelete()
		}
		else if (id = this.ID_CONTEXT_DELETEALL)
		{
			this.OnContextDeleteAll()
		}
		else if (id = this.ID_CONTEXT_SELECTALL)
		{
			this.OnContextSelectAll()
		}
		else if (id = this.ID_CONTEXT_SETUSED)
		{
			this.OnContextSetUsed(true)
		}
		else if (id = this.ID_CONTEXT_SETUNUSED)
		{
			this.OnContextSetUsed(false)
		}
		else
		{
			base.OnCommand(wParam, lParam, nMsg, hWnd)
		}
	}
	OnContentChanged(id)
	{
		if (this.bRunning)
		{
			return
		}
		if (id = this.editContent.id)
		{
			bRunnable := (this.editContent.GetWindowTextLength() > 0)
		}
		else
		{
			view := this.tabContent.GetCurChild()
			if (view.id != id)
			{
				return
			}
			bRunnable := (view.GetCount("S") > 0)
		}
		if (this.bRunnable && !bRunnable)
		{
			this.bRunnable := false
			this.UpdateButtons()
		}
		else if (!this.bRunnable && bRunnable)
		{
			this.bRunnable := true
			this.UpdateButtons()
		}
		else
		{
		}
	}
	OnContextCopy()
	{
		this.tabContent.GetCurChild().Copy()
	}
	OnContextCopyContent()
	{
		this.tabContent.GetCurChild().CopyContent()
	}
	OnContextDelete()
	{
		MsgBox, 4, 삭제 확인, 선택된 상품권을 정말로 삭제하시겠습니까?, 10
		IfMsgBox, Yes
		{
			this.tabContent.GetCurChild().Delete()
			this.UpdateStatistics()
		}
	}
	OnContextDeleteAll()
	{
		MsgBox, 4, 삭제 확인, 전체 상품권을 정말로 삭제하시겠습니까?, 10
		IfMsgBox, Yes
		{
			this.tabContent.GetCurChild().DeleteAll()
			this.UpdateStatistics()
		}
	}
	OnContextSelectAll()
	{
		this.tabContent.GetCurChild().SelectAll()
	}
	OnContextSetUsed(bUsed := true)
	{
		this.tabContent.GetCurChild().SetUsed(0, bUsed)
	}
	OnErase()
	{
		this.tabContent.SetCurSel(0)		
		this.tabLog.SetCurSel(0)		
		this.editLog.Clear()
		this.editContent.Clear()
		this.OnContentChanged(this.editContent.id)
	}
	OnFetch()
	{
		this.EnableButton(this.menu.edit, this.ID_EDIT_FETCH, false)
		this.InitLog()
		this.tabContent.SetCurSel(0)		
		if (this.setting.fetcher = 0)
		{
			fetcher := new CMSYourPhoneMessageReader()
		}
		else if (this.setting.fetcher = 1)
		{
			fetcher := new CKakaoTalkMessageReader()
		}
		else if (this.setting.fetcher = 2)
		{
			fetcher := new CGoogleMessageReader()
		}
		else if (this.setting.fetcher = 3)
		{
			fetcher := new CPushbulletMessageReader()
		}
		else
		{
			this.AppendLog("가져오기 : 지원되지 않는 방식입니다")
			return
		}
		this.AppendLogBar(fetcher.name " 가져오기")
		fetcher.SkipPinCheck(this.setting.fetcher_filter = 4)
		if (fetcher.Init() && fetcher.Fetch())
		{
			filter := ["", "북앤라이프", "해피머니", "컬쳐랜드", this.chrome.Unescape(this.setting.fetcher_keyword)]
			time := 0
			regex := filter[this.setting.fetcher_filter + 1]
			if (this.setting.fetcher_check_time)
			{
				time := (this.setting.fetcher_check_time = 1) ? A_Year A_MM A_DD "000000" : this.setting.fetcher_datetime
				FormatTime, filter_msg, %time%, yyyy-MM-dd HH:mm:ss
				filter_msg .= " 이후로 "
			}
			if (regex)
			{
				filter_msg .= "키워드 '" regex "' 로 검색한 결과`r`n`r`n 해당"
			}
			fetcher.Filter(time, regex)
			count := fetcher.messages.MaxIndex()
			if (count > 0)
			{
				Loop, %count%
				{
					FormatTime, msg_time, % fetcher.messages[A_Index].time, yyyy-MM-dd HH:mm:ss
					this.AppendContent("________________________________________________________<" msg_time ">____")
					this.AppendContent(StrReplace(fetcher.messages[A_Index].msg, "`n", "`r`n"))
				}
				if (count >= 1)
				{
					this.AppendLog("'" fetcher.name "' 의 현재 열린 " fetcher.page " 창에서 " filter_msg " 상품권으로 추정되는 총 " count "개의 메세지를 가져왔습니다")
					this.OnContentChanged(this.editContent.id)
				}
			}
			else
			{
				this.AppendLog("'" fetcher.name "' 의 현재 열린 " fetcher.page " 창에서 " filter_msg " 상품권으로 추정되는 메세지가 하나도 없습니다")
			}
		}
		else
		{
			this.AppendLog("가져오기 오류 : " fetcher.err)
		}
		this.AppendLogBar(fetcher.name " 가져오기")
		this.EnableButton(this.menu.edit, this.ID_EDIT_FETCH)
	}
	OnFileOpen()
	{
		FileSelectFile, files, M3, %A_ScriptDir%, 입력창으로 가져올 텍스트파일을 선택하세요
		Loop, parse, files, `n
		{
			if (A_Index = 1)
			{
				path := A_LoopField
			}
			else
			{
				FileRead, str, %path%\%A_LoopField%
				this.editContent.AppendText(str)
			}
		}
		this.tabContent.SetCurSel(0)		
		this.OnContentChanged(this.editContent.id)
	}
	OnFileSaveAs()
	{
		if (this.editContent.GetWindowTextLength() < 1)
		{
			this.InitLog()
			this.AppendLog("저장할 내용이 없습니다")
			return
		}
		option := "S" (2 | 16)
		FileSelectFile, file, %option%, %A_ScriptDir%, 입력창 내용을 저장할 파일을 지정하세요, Text Documents (*.txt)
		
		if (FileExist(file))
		{
			FileDelete, %file%
		}
		FileAppend, % this.editContent.ControlGetText(), %file%, UTF-8		
	}	
	OnKeyDown(wParam, lParam, nMsg, hWnd)
	{
		if (wParam = 13)
		{
			iSel := this.tabContent.GetCurSel()
			if (iSel != 0)
			{
				if (this.tabContent.children[iSel + 1].hwnd = hWnd)
				{
					if (this.tabContent.children[iSel + 1].GetCount("S") > 0)
					{
						this.PostMessage(0x0111, this.ID_TOOL_EXECUTE, 0)
						return 0
					}
				}
			}
		}
		return base.OnKeyDown(wParam, lParam, nMsg, hWnd)
	}
	OnLogTabChanged(id)
	{
		if (id = this.stats.id)
		{
			this.UpdateStatistics()
		}
	}
	OnNext()
	{
		if (this.giftcard)
		{
			this.giftcard.SetPage(this.giftcard.page + 1)
			this.AppendLog(this.giftcard.GetCurrentPageInfo())
			this.UpdateButtons()
		}
	}
	OnNotify(wParam, lParam, nMsg, hWnd)
	{
		static NM_CLICK := -2
		static NM_RCLICK := -5
		static LVN_FIRST := -100
		static LVN_LAST := -199
		static TCN_FIRST := - 550
		static TCN_LAST := -580
		static LVN_ITEMCHANGED :=  (LVN_FIRST-1)
		static LVN_COLUMNCLICK :=  (LVN_FIRST-8)
		static LVN_KEYDOWN := (LVN_FIRST - 55)
		static TCN_SELCHANGE  := (TCN_FIRST - 1)
		code := NumGet(lParam+0, 2 * A_PtrSize, "Int")
		if (code = NM_CLICK)
		{
			id := NumGet(lParam + 0, 1 * A_PtrSize, "UPtr")
			view := this.tabContent.GetCurChild()
			if (view.id = id)
			{
				view.bItemChanged := true
			}
		}
		else if (code = NM_RCLICK)
		{
			id := NumGet(lParam + 0, 1 * A_PtrSize, "UPtr")
			view := this.tabContent.GetCurChild()
			if (view.id = id)
			{
				bSelection := (view.GetCount("S") > 0)
				this.menu.context.Enable(this.ID_CONTEXT_COPY, bSelection)
				this.menu.context.Enable(this.ID_CONTEXT_DELETE, bSelection)
				this.menu.context.Enable(this.ID_CONTEXT_EXECUTE, bSelection)
				this.menu.context.Enable(this.ID_CONTEXT_SETUSED, bSelection)
				this.menu.context.Enable(this.ID_CONTEXT_SETUNUSED, bSelection)
				MouseGetPos, x, y
				Menu, % this.menu.context.name, Show, %x%, %y%
			}
		}
		else if (code = LVN_KEYDOWN)
		{
			id := NumGet(lParam + 0, 1 * A_PtrSize, "UPtr")
			view := this.tabContent.GetCurChild()
			if (view.id = id)
			{
				vkey := NumGet(lParam + 0, 3 * A_PtrSize, "UShort")
				if (vkey = GetKeyVK("A") && GetKeyState("Control"))
				{
					this.PostMessage(0x0111, this.ID_CONTEXT_SELECTALL, 0)
				}
				else if (view.GetCount("S") > 0)
				{
					if (vkey = GetKeyVK("C") && GetKeyState("Control"))
					{
						this.PostMessage(0x0111, this.ID_CONTEXT_COPY, 0)
					}
					else if (vkey = GetKeyVK("Delete"))
					{
						this.PostMessage(0x0111, this.ID_CONTEXT_DELETE, 0)
					}
				}
			}
		}
		else if (code = LVN_ITEMCHANGED)
		{
			id := NumGet(lParam + 0, 1 * A_PtrSize, "UPtr")
			if (id = this.tabContent.GetCurChildId())
			{
				this.OnContentChanged(id)
			}
		}
		else if (code = TCN_SELCHANGE)
		{
			id := NumGet(lParam + 0, 1 * A_PtrSize, "UPtr")
			if (id = this.tabLog.id)
			{
				this.tabLog.ShowChild()
				this.OnLogTabChanged(this.tabLog.GetCurChildId())
			}
			else if (id = this.tabContent.id)
			{
				this.tabContent.ShowChild()
				this.OnContentChanged(this.tabContent.GetCurChildId())
			}
		}
	}
	OnOptionSetting()
	{
		this.dlgAx := new CSettingDialog()
		if (this.dlgAx.DoModal(this.setting))
		{
			this.setting := this.dlgAx.setting
			this.PostMessage(this.WM_SETTING_CHANGED, 0, 0)
		}
		this.dlgAx := ""
	}
	OnPaste()
	{
		if(Clipboard)
		{
			this.tabContent.SetCurSel(0)		
			this.editContent.AppendText(Clipboard)
			this.OnContentChanged(this.editContent.id)
		}
	}
	OnPrev()
	{
		if (this.giftcard)
		{
			this.giftcard.SetPage(this.giftcard.page - 1)
			this.AppendLog(this.giftcard.GetCurrentPageInfo())
			this.UpdateButtons()
		}
	}
	OnSettingChanged(wParam, lParam, nMsg, hWnd)
	{
		this.InitChrome()
		if (this.giftcard)
		{
			if (this.giftcard.browser != this.setting.browser)
			{
				this.DeleteGiftCard()
			}
			if (this.giftcard.exchange)
			{
				this.giftcard.npp_default := this.setting.ex_charging_auto ? 10000 : 1
			}
		}
		if (this.setting.send_mode)
		{
			SendMode, Input
		}
		else
		{
			SendMode, Event
		}
		this.UpdateButtons()
	}
	OnViewLog()
	{
		this.InitLog()
	}
	OnViewStats()
	{
		this.InitLog()
		this.UpdateStatistics()
		this.tabLog.SetCurSel(1)
	}
	OnWebSocketDisconnected()
	{
		this.AppendLog(this.chrome.korname " : 연결이 끊어졌습니다. 다음 기능 실행시 자동으로 재연결됩니다")
		this.DeleteGiftCard()
	}
}
class CApplication extends CWindow
{
	__New(name, version, titletext)
	{
		this.name := name
		this.version := version
		this.titletext := titletext
		; GUI
		Gui, +Resize     +HWNDhWnd
		base.__New(hWnd)
		SetWinDelay, -1
		FileEncoding, UTF-8
		Hotkey, IfWinActive, % this.title
		this.m := A_ScreenDPI / 96
		this.toolbar := new CToolbarCtrl()
		this.tabLog := new CTabCtrl()
		this.editLog := new CEditCtrl("로그창", true)
		this.tabLog.Add(this.editLog)
		this.hotkeys := Object()
		this.menu := Object()
		this.AddMenu()
		this.AddToolbar()
		this.AddHotkey()
		this.toolbar_h := Round(42 * this.m)
		; Init
		this.InitIEEmulation()
		this.dlgAx := ""
		this.bRunnable := false
		this.bRunning := false
		this.bLogInit := false
		this.setting := { width : 800, height : 600}
		; 윈도우메세지핸들러
		OnMessage(0x0005, this.OnSize.Bind(this))
		OnMessage(0x004E, this.OnNotify.Bind(this))
		OnMessage(0x0100, this.OnKeyDown.Bind(this))
		OnMessage(0x0111, this.OnCommand.Bind(this))
		OnMessage(0x0112, this.OnSysCommand.Bind(this))
		OnMessage(0x0201, this.OnLButtonDown.Bind(this))
		this.WM_SETTING_CHANGED := 0x10000 + 1
		this.WM_WEBSOCKET_DISCONNECTED := 0x10000+ 2
		OnMessage(this.WM_SETTING_CHANGED, this.OnSettingChanged.Bind(this))
		OnMessage(this.WM_WEBSOCKET_DISCONNECTED, this.OnWebSocketDisconnected.Bind(this))
		; 타이머
		this.fnRun := this.Run.Bind(this)
		this.fnResizeOnce := this.ResizeOnce.Bind(this)
		timer := this.fnResizeOnce
		SetTimer, % timer, 300
		; 기타
		if A_AhkVersion >= 1.1.29
		{
			OnError(this.OnError.Bind(this))
		}
		else
		{
			this.AppendLog("오토핫키 버전(" A_AhkVersion ")이 너무 낮습니다. 최신버전으로 업데이트하세요")
		}
		this.OnUpdateCheck(false)
		this.LoadIcon()
		this.LoadSetting()
		this.InitApplication()
		; 마지막
		this.Show()
		this.ReleaseNote()
		this.PostMessage(this.WM_SETTING_CHANGED, 0, 0)
	}
	AddHotKey()
	{
	}
	AddMenu()
	{
	}
	AddToolbar()
	{
	}
	AppendLog(msg)
	{
		FormatTime, TimeString, , HH:mm:ss
		msg := "[" TimeString "] " msg "`r`n"
		this.editLog.AppendText(msg)
	}
	AppendLogBar(title)
	{
		this.AppendLog("__________________________________________________________________________<" title ">______")
	}
	EnableButton(ByRef menu, id, bEnable := true)
	{
		menu.Enable(id, bEnable)
		this.toolbar.Enable(id, bEnable)
	}
	ExitIfStop()
	{
		if (!this.bRunnable)
		{
			this.AppendLog("사용자에 의해 중단되었습니다")
			this.ResetRunState()
			Exit, 1
		}
	}
	GetWin10Version()
	{
		if (!InStr(A_OSVersion, "10."))
		{
			return 0
		}
		if A_OSVersion > 10.0.19041
		{
			return "2004+"
		}
		if A_OSVersion = 10.0.19041
		{
			return 2004
		}
		if A_OSVersion = 10.0.18363
		{
			return 1909
		}
		if A_OSVersion = 10.0.18362
		{
			return 1903
		}
		if A_OSVersion = 10.0.17763
		{
			return 1809
		}
		if A_OSVersion = 10.0.17134
		{
			return 1803
		}
		if A_OSVersion = 10.0.16299
		{
			return 1709
		}
		if A_OSVersion = 10.0.15063
		{
			return 1703
		}
		if A_OSVersion = 10.0.14393
		{
			return 1607
		}
		if A_OSVersion = 10.0.10586
		{
			return 1511
		}
		if A_OSVersion = 10.0.10240
		{
			return 1507
		}
		return 0
	}
	InitLog()
	{
		if (!this.bLogInit)
		{
			this.bLogInit:= true
			this.ResizeOnce()
			this.tabLog.Show()
		}
		this.tabLog.SetCurSel(0)
	}
	InitApplication()
	{
		this.bRunnable := true
		this.InitLog()
	}
	InitChrome()
	{
		if (this.chrome && (this.setting.browser = 0 || this.chrome.id = this.setting.browser))
		{
			return
		}
		if (this.setting.browser = 2)
		{
			this.chrome := new CMicrosoftEdge()
		}
		else if (this.setting.browser = 3)
		{
			this.chrome := new CNaverWhale()
		}
		else
		{
			this.chrome := new CChrome()
		}
		if (this.setting.browser)
		{
			this.AppendLog("현재 선택된 브라우저는 " this.chrome.korname " 입니다")
		}
	}
	InitIEEmulation()
	{
		if (!InStr(A_OSVersion, "WIN_") || SubStr(A_OSVersion, 5, 1) >= 7)
		{
            be := {"Default" : 0, "IE7" : 7000, "IE8" : 8000, "IE8STD" : 8888, "IE9" : 9000, "IE9STD" : 9999, "IE10" :10000, "IE10STD" : 10001, "IE11" : 11000, "IE11Edge" : 11001}
			emulation := be.IE11Edge
			RegRead, emul_current, HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION, AutoHotKey.exe
			if (emul_current != emulation)
			{
				RegWrite, REG_DWORD, HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION, AutoHotKey.exe, %emulation%
			}
		}
	}
	LoadIcon()
	{
		ico := this.name ".ico"
		if (InStr(A_ScriptName, ".exe") || !FileExist(ico))
		{
			return
		}
		hIcon := LoadPicture(ico, "Icon1 w32 h32", type)
		Gui +LastFound
		SendMessage 0x80, 0, hIcon
	}
	LoadSetting()
	{
		this.setting_file := this.name ".setting.json"
		if (FileExist(this.setting_file))
		{
			FileRead, str, % this.setting_file
			setting := JSON.Load(str)
			for key, val in % setting
			{
				if (!IsObject(val) && RegExMatch("^\d+$", val))
				{
					val := val + 0
				}
				this.setting[key] := val
			}
			this.setting.width := Max(100, this.setting.width)
			this.setting.height := Max(100, this.setting.height)
		}
	}
	ReleaseNote()
	{
		win10ver := this.GetWin10Version()
		if (win10ver > 0)
		{
			os := "윈도우10 버전" win10ver " (" A_OSVersion ")"
		}
		else
		{
			os := A_OSVersion
		}
		this.AppendLog("운영체제 : " os ", 오토핫키 : " A_AhkVersion " " (A_IsUnicode ? "Unicode" : "Ansi") " " (A_PtrSize = 8 ? "64" : "32") "-bit")
		if (A_Args.Length() > 1)
		{
			if (InStr(A_Args[1], "ahk_pid"))
			{
				this.InitLog()
				http := new CHttp()
				response := JSON.Load(http.Get("https://auto.ddart.net/download/" this.name "/note"))
				old := A_Args[4]
				note := response.note
				if (note)
				{
					if (old)
					{
						pos := InStr(note, "v" old)
						if (pos)
						{
							note := SubStr(note, pos)
						}
					}
					this.AppendLog(StrReplace(note, "`n", "`r`n"))
				}
				if (InStr(A_Args[5], ".exe"))
				{
					;; 업데이트 전에 exe 파일로 이용중이었음
					this.OnMakeExe()
				}
			}
		}
	}
	ResetRunState()
	{
		this.bRunning := false
		this.bRunnable := true
		this.UpdateButtons()
	}
	ResizeOnce()
	{
		timer := this.fnResizeOnce
		SetTimer, % timer, Off
		w := this.w
		h := this.h
		th := this.toolbar_h
		margin := 0
		margin *= this.m, th *= this.m, w *= this.m, h *= this.m
		this.tabLog.Move(margin, margin + th, w, h - th)
		this.toolbar.Move(margin, margin, w, th)
	}
	Run()
	{
		timer := this.fnRun
		SetTimer, %timer%, Off
		this.ResetRunState()
	}
	SaveSetting()
	{
		if (FileExist(this.setting_file))
		{
			FileDelete, % this.setting_file
		}
		FileAppend, % JSON.Dump(this.setting), % this.setting_file, UTF-8
	}
	Show()
	{
		this.w := this.setting.width
		this.h := this.setting.height
;		size := "w" this.w " h" this.h
		size := "w" Round(this.w / this.m ) " h" Round(this.h / this.m)
		this.ResizeOnce()
		Gui, 1:Show, %size%, % this.titletext
	}
	UpdateApplication()
	{
		this.InitLog()
		backup := "backup_v" this.version
		if (!FileExist(backup))
		{
			FileCreateDir, %backup%
		}
		if (RegExMatch(A_ScriptName, "O)(.+)\.(\w{3})", matches))
		{
			name := this.name
			ahk := A_ScriptDir "\" name ".ahk"
			zip := A_ScriptDir "\" name ".zip"
			dst := A_ScriptDir
			if (matches[1] = name)
			{
				FileMove, %name%.ahk, %backup%, true
				FileMove, %name%.exe, %backup%, true
			}
			try
			{
				UrlDownloadToFile, https://auto.ddart.net/download/%name%/current, %zip%
			}
			catch e
			{
				this.AppendLog(e.Message)
			}
			if (FileExist(zip))
			{
				this.AppendLog(zip)
				MsgBox, 4, 업데이트 확인, 업데이트 완료되었습니다. 업데이트반영을 위해 지금 재실행하시겠습니까? , 10
				IfMsgBox, Yes
				{
					obj := ComObjCreate("Shell.Application")
					obj.Namespace(dst).CopyHere(obj.Namespace(zip).items, 4|16)
					FileDelete, %zip%
					args := "ahk_pid " this.GetPID() " version " this.version " " A_ScriptName
					Run, %ahk% %args%
					this.OnFileExit()
				}			
			}
			else
			{
				this.AppendLog("업데이트 다운로드 실패")
			}
		}
	}
	UpdateButtons()
	{
		this.EnableButton(this.menu.tool, this.ID_TOOL_EXECUTE, !this.bRunning && this.bRunnable)
		this.EnableButton(this.menu.tool, this.ID_TOOL_STOP, this.bRunning && this.bRunnable)
	}
	OnChromeLaunch()
	{
		this.chrome.Launch(this.setting.chrome_debugging_port)
	}
	OnClose()
	{
		this.SaveSetting()
		return 0
	}
	OnCommand(wParam, lParam, nMsg, hWnd)
	{
		id := wParam & 0xFFFF
		notification_code := wParam >> 16
		if (id = this.ID_FILE_EXIT)
		{
			this.OnFileExit()
		}
		else if (id = this.ID_TOOL_EXECUTE)
		{
			this.OnExecute()
		}
		else if (id = this.ID_TOOL_STOP)
		{
			this.OnStop()
		}
		else if (id = this.ID_TOOL_CHROMELAUNCH)
		{
			this.OnChromeLaunch()
		}
		else if (id = this.ID_HELP_HELP)
		{
			this.OnHelp()
		}
		else if (id = this.ID_HELP_UPDATE)
		{
			this.OnUpdateCheck()
		}
		else if (id = this.ID_FILE_MAKEEXE)
		{
			this.OnMakeExe()
		}
		else
		{
		}
	}
	OnError(error)
	{

		this.AppendLog("오류발생 : " error.File " " error.Line "번째줄")
		this.AppendLog(error.Extra " : " error.Message)
		this.ResetRunState()
		return true
	}
	OnExecute()
	{
		if (this.bRunnable && !this.bRunning)
		{
			this.bRunning := true
			this.UpdateButtons()
			timer := this.fnRun
			SetTimer %timer%, 10, -10
		}		
	}
	OnFileExit()
	{
		this.PostMessage(0x0112, 0xF060, 0)
	}
	OnHelp()
	{
		Run, https://auto.ddart.net/xe/help
	}
	OnHotKey()
	{
		if (!this.Active())
		{
			return 0
		}
		cmd := this.hotkeys[A_ThisHotkey]
		if (cmd)
		{
			this.PostMessage(0x0111, cmd, 0)
		}
		else
		{
		}
	}
	OnKeyDown(wParam, lParam, nMsg, hWnd)
	{
		if (this.dlgAx && hWnd = this.dlgAx.hWndIE && this.dlgAx.iaxie.pi)
		{
			; AxIE에 일부 키 전달안되는 문제. TAB=9, ENTER=13, DELETE=46
			if (wParam = 9 || wParam = 13 || wParam = 46)
			{
				VarSetCapacity(msg, 7*A_PtrSize)
				for i,val in [hWnd, nMsg, wParam, lParam, A_EventInfo, A_GuiX, A_GuiY]
					NumPut(val, msg, (i-1)*A_PtrSize)
				this.dlgAx.iaxie.TranslateAccelerator(&msg)
				; 메세지 루프탈출
				return 0 
			}
		}
	}
	OnLButtonDown(wParam, lParam, nMsg, hWnd)
	{
	}
	OnMakeExe()
	{
		file := A_ScriptDir "\" this.name ".exe"
		ico := A_ScriptDir "\" this.name ".ico"
		compiler := StrReplace(A_AhkPath, "AutoHotkey.exe") "Compiler\Ahk2Exe.exe"
		this.InitLog()
		if (InStr(A_ScriptName, ".exe"))
		{
			this.AppendLog("이미 실행파일로 실행되었습니다.")
			return
		}
		if (!FileExist(compiler))
		{
			this.AppendLog(compiler "를 찾을수 없습니다")
			return 
		}
		if (FileExist(file))
		{
			FileDelete, %file%
			this.AppendLog("기존 " file " 를 지웁니다")
		}
		if (FileExist(ico))
		{
			icon_option = /icon "%ico%"
		}
		RunWait, "%compiler%" /in "%A_ScriptDir%\%A_ScriptName%" /out  "%file%" %icon_option%
		this.AppendLog(file " 가 생성되었습니다")
	}
	OnNotify(wParam, lParam, nMsg, hWnd)
	{
		id := NumGet(lParam + 0, 1 * A_PtrSize, "UPtr")
		if (id = this.tabLog.id)
		{
			TCN_FIRST := - 550
			TCN_SELCHANGE  := (TCN_FIRST - 1)
			TCN_SELCHANGING := (TCN_FIRST - 2)
			code := NumGet(lParam+0, 2 * A_PtrSize, "Int")
			if (code = TCN_SELCHANGE)
			{
				this.tabLog.ShowChild()
			}
		}
	}
	OnSettingChanged(wParam, lParam, nMsg, hWnd)
	{
	}
	OnSize(wParam, lParam, nMsg, hWnd)
	{
		if (hWnd = this.hwnd)
		{
			w := lParam & 0xFFFF
			h := lParam >> 16
			this.w := w
			this.h := h
			timer := this.fnResizeOnce
			SetTimer, % timer, Off
			SetTimer, % timer, On
		}
	}
	OnStop()
	{
		if (this.bRunning && this.bRunnable)
		{
			this.bRunnable := false
			this.UpdateButtons()
		}
	}	
	OnSysCommand(wParam, lParam, nMsg, hWnd)
	{
		if (wParam = 0xF060)
		{
			if (hWnd = this.hwnd)
			{
				if (this.OnClose())
				{
					return true
				}			
				ExitApp
			}
		}
	}
	OnUpdateCheck(bUser := true)
	{
		timestamp := A_Now
		timestamp -= 19700101000000, seconds
		name := this.name
		if (bUser)
		{
			this.InitLog()
		}
		else
		{
			RegRead, DisableAutoUpdate , HKEY_CURRENT_USER\Software\DDART\%name%, DisableAutoUpdate
			if (DisableAutoUpdate)
			{
				return
			}
			RegRead, LastUpdate , HKEY_CURRENT_USER\Software\DDART\%name%, LastUpdate
			if (LastUpdate && timestamp - LastUpdate < 12 * 60 * 60)
			{
				return 
			}
		}
		http := new CHttp()
		response := JSON.Load(http.Get("https://auto.ddart.net/download/" name "/version"))
		version := response.version
		RegWrite, REG_DWORD, HKEY_CURRENT_USER\Software\DDART\%name%, LastUpdate, %timestamp%
		if (this.version = version)
		{
			this.AppendLog("현재 " this.version " 버전은 최신버전입니다")
		}
		else if (this.version < version)
		{
			MsgBox, 4, 업데이트확인, 새로운 버전(%version%) 이 있습니다. 다운받으시겠습니까?, 10
			IfMsgBox, Yes
			{
				RegWrite, REG_DWORD , HKEY_CURRENT_USER\Software\DDART\%name%, DisableAutoUpdate, 0
				this.UpdateApplication()
			}
			else if (!bUser)
			{
				RegWrite, REG_DWORD , HKEY_CURRENT_USER\Software\DDART\%name%, DisableAutoUpdate, 1
			}
		}
		else if (!version)
		{
			this.AppendLog("현재 서버문제로 최신버전 확인을 할수가 없습니다")
		}
		else
		{
			this.AppendLog("개발자?")
		}
	}
	OnWebSocketDisconnected()
	{
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Windows & Controls
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CWindow
{
	__New(hwnd)
	{
		this.hwnd := hwnd
		this.title := "ahk_id " this.hwnd
	}
	Activate()
	{
		WinActivate, % this.title
	}
	Active()
	{
		return WinActive(this.title)
	}
	Exist()
	{
		return WinExist(this.title)
	}
	Get(subcmd)
	{
		WinGet, var, %subcmd%, % this.title
		return var
	}
	GetClass()
	{
		WinGetClass, var, % this.title
		return var
	}
	GetControlList()
	{
		return this.Get("ControlList")
	}
	GetPID()
	{
		return this.Get("PID")
	}
	GetProcessName()
	{
		return this.Get("ProcessName")
	}
	GetTitle()
	{
		WinGetTitle, var, % this.title
		return var
	}
	Move(x, y, w := "", h := "")
	{
		WinMove, % this.title, , x, y, w, h
	}
	Control(name, subcmd, value :="")
	{
		Control, %subcmd%, %value%, %name%, % this.title
	}
	ControlFocus(name := "")
	{
		ControlFocus, %name%, % this.title
	}
	ControlGet(name, subcmd := "hwnd", value := "")
	{
		ControlGet, outvar, %subcmd%, %value%, %name%, % this.title
		return outvar
	}
	ControlGetText(name = "")
	{
		ControlGetText, text, %name%, % this.title
		return text
	}
	ControlSend(name, keys)
	{
		ControlSend, %name%, %keys%, % this.title
	}
	ControlSetText(name, txt)
	{
		ControlSetText, %name%, %txt%, % this.title
	}
	SendMessage(msg, wParam :=0, lParam := 0, timeout := 5000)
	{
		SendMessage, %msg%, %wParam%, %lParam%, , % this.title, , , , %timeout%
	}
	PostMessage(msg, wParam := 0, lParam :=0)
	{
		PostMessage, %msg%, %wParam%, %lParam%, , % this.title
	}
	GetWindowTextLength()
	{
		WM_GETTEXTLENGTH := 0x0E
		this.SendMessage(WM_GETTEXTLENGTH, 0, 0)
		return ErrorLevel
	}
	MakeLong(lo, hi)
	{
		return (hi << 16) | (lo & 0xffff)
	}
}
class CMenu
{
	__New(name)
	{
		this.name := name
	}
	Add(item, sub := "", bEnable := true)
	{
		if (item)
		{
			handler := sub ? ":" sub.name : CMenu.Handler
			Menu, % this.name, Add, %item%, %handler%
			return this.GetLastId()
		}
		else
		{
			Menu, % this.name, Add
		}
	}
	GetLastId()
	{
		hMenu := MenuGetHandle(this.name)
		count := DllCall("GetMenuItemCount", "ptr", hMenu)		
		return DllCall("GetMenuItemID", "ptr", hMenu, "int", count-1)
	}
	GetState(id, flags := 0)
	{
		hMenu := MenuGetHandle(this.name)
		return DllCall("GetMenuState", "ptr", hMenu, "uint", id, "uint", flags)		
	}
	IsEnabled(id)
	{
		return ! this.IsDisabled(id)
	}
	IsDisabled(id)
	{
		return this.GetState(id)  & 3
	}
	Enable(id, bEnable := true)
	{
		hMenu := MenuGetHandle(this.name)
		uEnable := bEnable ? 0x00 : 0x01
		return DllCall("EnableMenuItem", "ptr", hMenu, "uint", id, "uint", uEnable)
	}
	Rename(item, name)
	{
		Menu, % this.name, Rename, %item%, %name%
	}
	Handler(ItemName, ItemPos, MenuName)
	{
	}
}

class CControl extends CWindow
{
	__New(hwnd)
	{
		static id := 3
		base.__New(hwnd)
		this.id := this.GetCtrlID()
	}
	Show(bShow := true)
	{
		this.Control("", bShow ? "Show" : "Hide")
	}
	GetCtrlID()
	{
		GWL_ID := -12
		if (A_PtrSize = 8)
		{
			return DllCall("GetWindowLongPtr", "ptr", this.hwnd, "int", GWL_ID)
		}
		else
		{
			return DllCall("GetWindowLong", "int", this.hwnd, "int", GWL_ID)
		}
	}
	SetCtrlID(id)
	{
		this.id := id
		GWL_ID := -12
		if (A_PtrSize = 8)
		{
			DllCall("SetWindowLongPtr", "ptr", this.hwnd, "int", GWL_ID, "int", id)
		}
		else
		{
			DllCall("SetWindowLong", "int", this.hwnd, "int", GWL_ID, "int", id)
		}
	}
}
class CEditCtrl extends CControl
{
	__New(name, bReadOnly := false)
	{
		this.name := name
		ES_MULTILINE := 0x0004, ES_AUTOVSCROLL := 0x0040, ES_READONLY := 0x0800
		style := ES_MULTILINE | ES_AUTOVSCROLL
		if (bReadOnly)
		{
			style |= ES_READONLY
		}
		Gui, Add, Edit,   HWNDhWnd %style% hidden
		base.__New(hWnd)
	}
	Clear()
	{
		this.SetSel(0, -1)
		text := ""
		this.ReplaceSel(text)
	}
	SetSel(nStartChar, nEndChar)
	{
		EM_SETSEL := 0xB1
		this.SendMessage(EM_SETSEL, nStartChar, nEndChar)
	}
	ReplaceSel(ByRef text, bCanUndo := false)
	{
		EM_REPLACESEL := 0xC2
		this.SendMessage(EM_REPLACESEL, bCanUndo, &text)
	}
	InsertText(nInsertAfterChar, ByRef text, bCanUndo := false)
	{
		this.SetSel(nInsertAfterChar, nInsertAfterChar)
		this.ReplaceSel(text, bCanUndo)
		return ErrorLevel
	}	
	AppendText(ByRef text, bCanUndo :=false)
	{
		this.InsertText(this.GetWindowTextLength(), text, bCanUndo)
	}
	GetLimitText()
	{
		EM_GETLIMITTEXT := 0x00D5
		this.SendMessage(EM_GETLIMITTEXT, 0, 0)
		return ErrorLevel
	}
	SetLimitText(nMax)
	{
		EM_SETLIMITTEXT := 0x00C5
		this.SendMessage(EM_SETLIMITTEXT, nMax, 0)
	}
	
}
class CToolbarCtrl extends CControl
{
	__New()
	{
		TBSTYLE_WRAPABLE := 0x0200, TBSTYLE_FLAT := 0x0800, TBSTYLE_LIST := 0x1000, TBSTYLE_TRANSPARENT := 0x8000, TBSTYLE_EX_MIXEDBUTTONS := 0x00000008, BTNS_SHOWTEXT :=  0x0040
		style := TBSTYLE_WRAPABLE |  TBSTYLE_FLAT | TBSTYLE_LIST |  TBSTYLE_TRANSPARENT |  TBSTYLE_EX_MIXEDBUTTONS  | BTNS_SHOWTEXT
		Gui, Add, Custom, ClassToolbarWindow32 HWNDhWnd %style%
		base.__new(hWnd)
	}
     SetMaxTextRows(MaxRows := 0)
    {
		WM_USER := 0x0400
		TB_SETMAXTEXTROWS :=  (WM_USER + 60)
        this.SendMessage(this.TB_SETMAXTEXTROWS, MaxRows, 0)
        return (ErrorLevel = "FAIL") ? False : true
    }
	
    SetImageList(IL_Default)
    {
		WM_USER := 0x0400
		TB_SETIMAGELIST :=  (WM_USER + 48)
        this.SendMessage(TB_SETIMAGELIST, 0, IL_Default)
        return (ErrorLevel = "FAIL") ? False : true
    }
	SetButtonSize(width, height)
	{
	}
	SetButtonWidth(min, max)
	{
		WM_USER := 0x0400
		TB_SETBUTTONWIDTH := (WM_USER + 59)
		this.SendMessage(TB_SETBUTTONWIDTH, 0, this.MakeLong(min, max))
	}
	Enable(id, bEnable := true)
	{
		TB_ENABLEBUTTON := 0x0401
		this.SendMessage(TB_ENABLEBUTTON, id, bEnable)
	}
	AddString(str)
	{
		WM_USER := 0x0400
		TB_ADDSTRINGA := (WM_USER + 28)
		TB_ADDSTRINGW := (WM_USER + 77)
		TB_ADDSTRING := A_IsUnicode ? TB_ADDSTRINGW : TB_ADDSTRINGA
		VarSetCapacity(pstr, (StrPut(str) * (A_IsUnicode ? 2 : 1), 0))
		StrPut(str, &pstr, StrPut(str) * (A_IsUnicode ? 2 : 1))
		this.SendMessage(TB_ADDSTRING, 0, &pstr)
		return ErrorLevel		
	}
	AddButton(i, id, str := "", state := 0x04, style := 0)
	{
		TBSTATE_ENABLED := 0x04
		WM_USER := 0x0400
		TB_ADDBUTTONS := (WM_USER + 20)
		istr := str ? this.AddString(str) : -1
		VarSetCapacity(ptbbutton, 8 + (A_PtrSize * 3), 0)
		NumPut(i, ptbbutton, 0, "Int")
		NumPut(id, ptbbutton, 4, "Int")
		NumPut(state, ptbbutton, 8, "Char")
		NumPut(style, ptbbutton, 9, "Char")
		NumPut(istr, ptbbutton, 8 + (A_PtrSize * 2), "Ptr")		
		this.SendMessage(TB_ADDBUTTONS, 1, &ptbbutton)
	}
    AutoSize()
    {
		WM_USER := 0x0400
		TB_AUTOSIZE := (WM_USER + 33)
        this.PostMessage(TB_AUTOSIZE, 0, 0)
        return ErrorLevel ? False : true
    }
}
class CToolbarButton
{
	__New(id, text, icono, icofile := "wmploc.dll")
	{
		this.id := id
		this.text := text
		this.icono := icono
		this.icofile := icofile
	}
}
class CRect
{
	__New(l, t, r, b)
	{
		this.l := l + 0
		this.t := t + 0
		this.r := r + 0
		this.b := b + 0
	}
}
class CTabCtrl extends CControl
{
	__New()
	{
		Gui, Add, Custom, ClassSysTabControl32 HWNDhWnd hidden
		base.__New(hWnd)
		this.children := Array()
	}
	Add(child)
	{
		i := this.children.Length()
		this.InsertItem(i, child.name)
		this.children.Push(child)
	}
	AdjustRect(ByRef rc, bLarger := false)
	{
		TCM_FIRST := 0x1300 
		TCM_ADJUSTRECT := (TCM_FIRST + 40)
		VarSetCapacity(prc, 4 * 4, 0)
		NumPut(rc.l, prc, 0, "Int")
		NumPut(rc.t, prc, 4, "Int")
		NumPut(rc.r, prc, 8, "Int")
		NumPut(rc.b, prc, 12, "Int")
		this.SendMessage(TCM_ADJUSTRECT, bLarger, &prc)
		rc.l := NumGet(&prc, 0, "Int")
		rc.t := NumGet(&prc, 4, "Int")
		rc.r := NumGet(&prc, 8, "Int")
		rc.b := NumGet(&prc, 12, "Int")
	}
	Exist(name)
	{
		Loop, % this.children.Length()
		{
			if (this.children[A_Index].name = name)
			{
				return true
			}
		}
		return false
	}
	GetCurSel()
	{
		TCM_FIRST := 0x1300 
		TCM_GETCURSEL := (TCM_FIRST + 11)
		this.SendMessage(TCM_GETCURSEL, 0, 0)
		return ErrorLevel
	}
	GetCurSelName()
	{
		i := this.GetCurSel() + 1
		return this.children[i].name
	}
	GetCurChild()
	{
		return this.children[this.GetCurSel() + 1]
	}
	GetCurChildId()
	{
		return this.children[this.GetCurSel() + 1].id
	}
	HighlightItem(iItem, fHighlight := 1)
	{
		TCM_FIRST := 0x1300 
		TCM_HIGHLIGHTITEM  := (TCM_FIRST + 51)
		this.SendMessage(TCM_HIGHLIGHTITEM, iItem, fHighlight)
	}
	Move(x, y, w, h)
	{
		base.Move(x, y, w, h)
		rc := new CRect(x, y, x+ w, y +h)
		this.AdjustRect(rc)
		Loop, % this.children.MaxIndex()
		{
			if (this.children[A_Index].hwnd)
			{
				this.children[A_Index].Move(rc.l, rc.t, rc.r - rc.l, rc.b - rc.t)
			}
		}
	}
	InsertItem(iItem, str)
	{
		TCM_FIRST := 0x1300 
		TCM_INSERTITEM := A_IsUnicode ? (TCM_FIRST + 62) : (TCM_FIRST + 7)
		TCIF_TEXT := 0x0001
		VarSetCapacity(pitem, A_PtrSize = 8 ? 40 : 28, 0)
		VarSetCapacity(pstr , StrPut(str)*(A_IsUnicode ? 2:1),0)
		StrPut(str, &pstr, StrPut(str) * (A_IsUnicode ? 2 : 1))
		NumPut(TCIF_TEXT,pitem,0,"UInt")                   
		NumPut(&pstr,  pitem,A_PtrSize=8 ? 16:12,"Ptr") 
		NumPut(StrPut(str), pitem,A_PtrSize=8 ? 24:16,"Int")
		this.SendMessage(TCM_INSERTITEM, iItem, &pitem)
	}
	SetCurFocus(iItem)
	{
		TCM_FIRST := 0x1300 
		TCM_SETCURFOCUS  := (TCM_FIRST + 48)
		this.SendMessage(TCM_SETCURFOCUS, iItem, 0)
	}
	SetCurSel(iItem)
	{
		TCM_FIRST := 0x1300 
		TCM_SETCURSEL :=  (TCM_FIRST + 12)
		this.SendMessage(TCM_SETCURSEL, iItem, 0)		
		this.ShowChild()
	}
	Select(name)
	{
		Loop, % this.children.MaxIndex()
		{
			if (name = this.children[A_Index].name)
			{
				this.SetCurSel(A_Index - 1)
				return this.children[A_Index]
			}
		}
	}
	ShowChild()
	{
		if (!this.ControlGet("", "Visible"))
		{
			return
		}
		iSel := this.GetCurSel()
		Loop, % this.children.MaxIndex()
		{
			if (this.children[A_Index].hwnd)
			{
				this.children[A_Index].Show(A_Index = iSel + 1)
				this.children[A_Index].ControlFocus()
			}
		}
	}
}
class CListView extends CControl
{
	__New(name, options := "", row_height := 20)
	{
		this.name := name
		Gui, Add, ListView, HWNDhWnd %options% hidden
		DllCall("UxTheme.dll\SetWindowTheme", "Ptr", hWnd, "WStr", "Explorer", "Ptr", 0)		
		LV_SetImageList(DllCall( "ImageList_Create", Int, 1, Int, row_height , Int, 8, Int, 1, Int, 1), 1)
		base.__New(hWnd)
	}
	Activate()
	{
		Gui, ListView, % this.hWnd
	}
	Add(options, cols*)
	{
		this.Activate()
		return LV_Add(options, cols*)
	}
	DeleteAll()
	{
		this.Activate()
		LV_Delete()
	}
	Delete(row)
	{
		this.Activate()
		LV_Delete(row)
	}
	Insert(row, options, cols*)
	{
		this.Activate()
		LV_Insert(row, options, cols*)
	}
	Modify(row, options, cols*)
	{
		this.Activate()
		LV_Modify(row, options, cols*)
	}
	ModifyCol(col, options, title)
	{
		this.Activate()
		LV_ModifyCol(col, options, title)
	}
	InsertCol(col, options, title)
	{
		this.Activate()
		LV_InsertCol(col, options, title)
	}
	DeleteCol(col)
	{
		this.Activate()
		LV_DeleteCol(col)
	}
	GetCount(mode :="")
	{
		this.Activate()
		return LV_GetCount(mode)
	}
	GetNext(params*)
	{
		this.Activate()
		return LV_GetNext(params*)
	}
	GetText(row, col := 1)
	{
		this.Activate()
		LV_GetText(var, row, col)
		return var
	}
	SetImageList(params*)
	{
		this.Activate()
		return LV_SetImageList(params*)
	}
	EnsureVisible(iItem, fPartialOK := 0)
	{
		LVM_FIRST := 0x1000
		LVM_ENSUREVISIBLE := (LVM_FIRST + 19)
		this.SendMessage(LVM_ENSUREVISIBLE, iItem, fPartialOK)
	}
}
class CGiftcodeView extends CListView
{
	__New(name)
	{
		base.__New(name, "NoSortHdr")
		this.delimiter := "`t"
		this.rows := Array()
		this.cols        := ["", "등록일", "핀번호", "사용여부"]
		this.col_props := ["0", "100 center", "300 center", "100 center"]
		this.file := "db\" name ".txt"		
		this.stats := [0, 0, 0]
		this.InitHeader()
		this.Load()
		this.bChanged := false
		this.bItemChanged := false
		this.selections := Array()
	}
	InitHeader()
	{
		Loop, % this.cols.MaxIndex()
		{
			this.InsertCol(A_Index, this.col_props[A_Index], this.cols[A_Index])
		}
	}
	Exist(col, value)
	{
		Loop, % this.rows.MaxIndex()
		{
			if (this.rows[A_Index][col] = value)
			{
				return A_Index
			}
		}
		return 0
	}
	AddCounter(date, variation :=1)
	{
		today := A_YEAR A_MM A_DD "000000"
		thismon := A_YEAR A_MM "01000000"
		this.stats[1] += variation
		if (date > thismon)
		{
			this.stats[2] += variation
		}
		if (date > today)
		{
			this.stats[3] += variation
		}
	}
	Add(options, cols*)
	{
		if (cols.MaxIndex() = 3)
		{
			this.rows.Push(cols)
			this.AddCounter(cols[1])
			FormatTime, date, % cols[1], yyyy-MM-dd
			base.Add(options, "", date, cols[2], cols[3] ? "O" : "X")
			this.bChanged := true
			this.bItemChanged := true
			return true
		}
		return false
	}
	Copy()
	{
		line := ""
		row := 0
		while(row := this.GetNext(row))
		{
			line .= this.rows[row][2] "`r`n"
		}
		Clipboard := line
	}
	CopyContent()
	{
		line := ""
		row := 0
		while(row := this.GetNext(row))
		{
			FormatTime, date, % this.rows[row][1], yyyy-MM-dd HH:mm:ss
			use := this.rows[row][3] ? "O" : "X"
			line .= date this.delimiter this.rows[row][2] this.delimiter use "`r`n"
		}
		Clipboard := line
	}
	Delete()
	{
		row :=0
		while(row := this.GetNext(row))
		{
			this.AddCounter(this.rows[row][1], -1)
			this.rows.RemoveAt(row)
			base.Delete(row)
			row--
			this.bChanged := true
			this.bItemChanged := true
		}
	}
	DeleteAll()
	{
		this.rows := Array()
		base.DeleteAll()
		this.bChanged := true
		this.bItemChanged := true
		this.selections := Array()
		this.stats := [0, 0, 0]
	}
	ModifyValue(row, col, val)
	{
		if (row <= this.rows.MaxIndex() && col <= this.cols.MaxIndex())
		{
			this.rows[row][col] := val
			if (col = 3)
			{
				val := val ? "O" : "X"
			}
			this.Modify(row, "Col" (col + 1), val)
			this.bChanged := true
		}
	}
	SetUsed(row := 0, bUsed := true)
	{
		if (row = 0)
		{
			while(row := this.GetNext(row))
			{
				this.SetUsed(row, bUsed)
			}
		}
		else
		{
			this.ModifyValue(row, 3, bUsed)
		}
	}
	Load()
	{
		if (!FileExist(this.file))
		{
			return false
		}
		FileRead, txt, % this.file
		Loop, Parse, txt, `n, `r
		{
			if (!A_LoopField)
			{
				continue
			}
			arr := Array()
			Loop, Parse, A_LoopField, % this.delimiter
			{
				arr.Push(A_LoopField)
			}
			this.Add("", arr*)
		}
		this.ScrollToEnd()
	}	
	Save()
	{
		if (!this.bChanged)
		{
			return
		}
		if (!FileExist("db"))
		{
			FileCreateDir, db
		}
		if (FileExist(this.file))
		{
			FileDelete, % this.file
		}
		Loop, % this.rows.MaxIndex()
		{
			row := A_Index
			Loop, % this.rows[row].MaxIndex()
			{
				line .= this.rows[row][A_Index]
				if (A_Index = this.rows[row].MaxIndex())
				{
					line .= "`r`n"
				}
				else
				{
					line .= this.delimiter
				}
			}
		}
		FileAppend, %line%, % this.file, UTF-8
	}
	SelectAll(bSelect := true)
	{
		this.Modify(0, bSelect ? "Select" : "-Select")
		this.bItemChanged := true		
	}
	ScrollToEnd()
	{
		iItem := this.GetCount() - 1
		if (iItem >= 0)
		{
			this.EnsureVisible(iItem)
		}
	}
}
class CStatisticsView extends CListView
{
	__New(name)
	{
		base.__New(name)
		this.InitHeader()
	}
	InitHeader()
	{
		col := 1
		this.InsertCol(col++, "0", "")
		this.InsertCol(col++, "150 center sort", "상품권 종류")
		this.InsertCol(col++, "100 float right", "전체")
		this.InsertCol(col++, "100 float right", "이번달")
		this.InsertCol(col++, "100 float right", "오늘")
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; ModalDialog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CModalDialog extends CWindow
{
	__New(html, w, h, title := "")
	{
		Gui, popup:+Owner1 +hWndhWnd -Resize -MaximizeBox -MinimizeBox
		Gui, popup:Add, ActiveX, hWndhWndAX x0 y0 w%w% h%h%, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		base.__New(hWnd)
		Sleep, 100
		wb := WBGet("ahk_id " hWndAX)
		wb.document.open()
		wb.document.write(html)
		wb.document.close()		
		Loop, 10
		{
			if (wb.document.readyState = "complete")
			{
				break
			}
			Sleep, 50
		}
		winAX := new CWindow(hWndAX)
		this.hWndIE := winAX.ControlGet("Internet Explorer_Server1")
		this.iaxie := new CIOleInPlaceActiveObject(wb)
		this.ie := wb.document.parentWindow
		this.ie._EventHandler := this._EventHandler.Bind(this)
		this.Init()
		Gui, 1:+Disabled
		Gui, popup:Show, w%w% h%h%, %title%
		this.clicked_button := 0
		this.ID_CANCEL := 0
		this.ID_OK := 1
	}
	_EventHandler(e)
	{
		if (this["On" e.type])
		{
			this["On" e.type](e)
		}
	}
	OnClick(e)
	{
		if (e.srcElement.type = "button")
		{
			if (e.srcElement.value = "확 인")
			{
				if (!this.ApplyChange())
				{
					return
				}
				this.clicked_button := this.ID_OK
			}
			else
			{
				this.clicked_button := this.ID_CANCEL
			}
			WM_CLOSE := 0x10
			this.PostMessage(WM_CLOSE, 0, 0)
		}
	}
	ApplyChnage()
	{
		return false
	}
	DoModal()
	{
		WinWaitClose, % this.title
		Gui, 1:Show
		Gui, 1:-Disabled
		Gui, popup:Hide
		Gui, popup:Destroy
		return this.clicked_button
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Setting & Dialogs
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CSetting
{
	__New()
	{
		this.width := 800
		this.height := 1000
		this.browser := 0
		this.fetcher := 0
		this.fetcher_check_time := 1
		this.fetcher_datetime := A_Year A_MM A_DD "000000"
		this.fetcher_filter := 0
		this.fetcher_keyword := ""
		this.chrome_debugging_port := 9222
		this.send_mode := 0
		this.key_delay := 50
		this.send_interval := 100
		this.ex_charging_interval := 500
		this.ex_charging_auto := 1
		this.ex_charging_target := 0
		this.skip_send_logging := 0
	}
}
class CSettingDialog extends CModalDialog
{
	__New()
	{
		w := 300
		h := 450
		html =
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
html{width:100`%;height:100`%; font-size :1em}
body {margin:0;padding:0;overflow: hidden;font-size: 0.75rem; background-color:#F0F0F0;width:100`%;height:100`%;}
table{width:100`%;height:100`%; border-spacing:0}
td{font-size:0.75rem;}
.setting td:nth-child(1) {width: 30`%; text-align: right}
.setting td:nth-child(2) {padding-left:1.25rem}
.setting input{ border-radius: 0.2em; border : 1px solid #ADADAD}
.setting input[type=checkbox] {}
.setting input[type=text] {width:3.75rem; text-align:right;}
.setting input[type=button] {background-color:#E1E1E1;width:5em;height:1.563rem; }
td.bottom{align:right; padding:0.625rem;}
.separator > td {border-top: 1px solid #ADADAD;}
#fetcher_keyword{width: 8.75rem;text-align:left}
</style>
<script>
var setting = null;
var proptype_checkbox = {"browser" : true, "fetcher" : true, "fetcher_check_time" : true, "fetcher_filter" : true, "send_mode" : true, "skip_send_logging" : true, "ex_charging_auto" : true, "ex_charging_target" : true};
var beforeIE9 = document.getElementsByClassName ? false : true;
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function Init(data)
{
	if (data)
	{
		setting = JSON.parse(data);
	}
	for (prop in setting)
	{
		if (proptype_checkbox[prop])
		{
			var elms = document.getElementsByClassName(prop);
			for (var i=0; i < elms.length; i++)
			{
				elms[i].checked = (i == setting[prop]);
				elms[i].addEventListener("click", OnClickCheckbox)
			}
		}
		else
		{
			var elm = document.getElementById(prop);
			if (elm)
			{
				elm.value = setting[prop];
			}		
		}	
	}
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
	DisplayClassElements("chrome_display", setting.browser);
	DisplayClassElements("send_display", setting.send_mode == 0);
	ShowDateTimeDisplay(setting.fetcher_check_time == 2);
	EnableFetcherKeyword(setting.fetcher_filter == 4);
	document.getElementById('fetcher_keyword').value = unescape(setting.fetcher_keyword);
	document.getElementById("datetime_display").style.display = (setting.fetcher_check_time != 2) ? "none" : "";	
	DisplayClassElements("exchange_display", setting.ex_charging_auto);
}
function DisplayClassElements(name, bShow)
{
	var elms = document.getElementsByClassName(name);
	for (var i = 0; i < elms.length; i++)
	{
		elms[i].style.display = bShow ? "" : "none";
	}
}
function EnableFetcherKeyword(bEnable)
{
	document.getElementById('fetcher_keyword').disabled = !bEnable
}
function ShowDateTimeDisplay(bShow)
{
	document.getElementById("datetime_display").style.display = bShow ? "" : "none";
	_ShowDateTime(bShow, document.getElementById("datetime_display").offsetTop);
}
function Submit()
{
	for (prop in setting)
	{
		if (proptype_checkbox[prop])
		{
			var elms = document.getElementsByClassName(prop);
			for (var i=0; i < elms.length; i++)
			{
				if  (elms[i].checked)
				{
					setting[prop] = i;
					break;
				}
			}
			
		}
		else
		{
			var elm = document.getElementById(prop)
			if (elm)
			{
				if (prop == "fetcher_keyword")
				{
					setting[prop] = escape(elm.value);
				}
				else
				{
					setting[prop] = parseInt(elm.value);
				}
			}
		}
	}
	return JSON.stringify(setting);
}
function OnClickCheckbox(e)
{
	var elms = document.getElementsByClassName(e.srcElement.className);
	for (var i=0; i < elms.length; i++)
	{
		if (elms[i] == e.srcElement)
		{
			if (elms[i].className == "browser")
			{
				DisplayClassElements("chrome_display", i);
				// DateTime 재배치
				ShowDateTimeDisplay(document.getElementById("datetime_display").style.display == "");
			}
			else if (elms[i].className == "ex_charging_auto")
			{
				DisplayClassElements("exchange_display", i);
			}
			else if (elms[i].className == "fetcher_check_time")
			{
				ShowDateTimeDisplay(i == 2);
			}
			else if (elms[i].className == "fetcher_filter")
			{
				EnableFetcherKeyword(i == 4);
			}
			else if (elms[i].className == "send_mode")
			{
				DisplayClassElements("send_display", i == 0);
			}
		}
		else
		{
			elms[i].checked = false;
		}
	}
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td>브라우저</td>
	<td> 
	  <input type=checkbox class=browser> 익스플로러 <input type=checkbox class=browser>크롬<br>
	  <input type=checkbox class=browser> 크로미움엣지 <input type=checkbox class=browser> 웨일
	</td>
  </tr>
  <tr class=chrome_display>
    <td>디버깅 포트</td>
	<td> <input type=text maxlength=5 id=chrome_debugging_port> (default: 9222)</td>
  </tr>
  <tr class=separator>
    <td>가져오기 대상</td>
	<td>
	   <input type=checkbox class=fetcher> 사용자휴대폰 <input type=checkbox class=fetcher>카카오톡<br>
	   <input type=checkbox class=fetcher> 구글메시지 &nbsp;<input type=checkbox class=fetcher>Pushbullet
	</td>
  </tr>
  <tr>
    <td>가져오기 범위</td>
	<td><input type=checkbox class=fetcher_check_time> 전부 <input type=checkbox class=fetcher_check_time> 오늘 <input type=checkbox class=fetcher_check_time> 지정이후
	</td>
  </tr>
   <tr id=datetime_display height=25>
    <td></td>
	<td>
	</td>
  </tr>
  <tr>
    <td>가져오기 필터</td>
	<td>
	   <input type=checkbox class=fetcher_filter> 사용안함 <input type=checkbox class=fetcher_filter>북앤라이프<br>
	   <input type=checkbox class=fetcher_filter> 해피머니 <input type=checkbox class=fetcher_filter>컬쳐랜드<br>
	   <input type=checkbox class=fetcher_filter> <input type=text id=fetcher_keyword>
	</td>
  </tr>
  <tr class=separator>
    <td>키입력 모드</td>
	<td> <input type=checkbox class=send_mode> 이벤트 <input type=checkbox class=send_mode> 연속 </td>
  </tr>
  <tr class=send_display>
    <td>키사이 지연</td>
	<td> <input type=text maxlength=3 id=key_delay> msec (10~999)</td>
  </tr>
  <tr>
    <td>칸사이 지연</td>
	<td> <input type=text maxlength=3 id=send_interval> msec (0~999)</td>
  </tr>
  <tr>
    <td>키입력 로깅</td>
	<td> <input type=checkbox class=skip_send_logging> 켜기 <input type=checkbox class=skip_send_logging>끄기</td>
  </tr>
  <tr class=separator>
    <td>교환권 충전방식</td>
	<td> <input type=checkbox class=ex_charging_auto> 수동 <input type=checkbox class=ex_charging_auto> 자동</td> 
  </tr>
  <tr class=exchange_display>
    <td>교환권 충전대상</td>
	<td> <input type=checkbox class=ex_charging_target> 캐시 <input type=checkbox class=ex_charging_target> 핀번호</td> 
  </tr>
  <tr class=exchange_display>
    <td>교환권사이 지연</td>
	<td> <input type=text maxlength=4 id=ex_charging_interval> msec (0~9999)</td>
  </tr>
  <tr class=separator>
	<td colspan=2 class=bottom> 
	   <input type=button class=button value="취 소">&nbsp; 
	   <input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)
		base.__New(html, w, h, "설정")
		Gui, popup:Add, DateTime, HWNDhWndDateTime w150 hidden, yyyy-MM-dd HH:mm:ss
		this.dtPicker := new CControl(hWndDateTime)
		this.ie._ShowDateTime := this._ShowDateTime.Bind(this)
		
		DllCall("BringWindowToTop", "Uint", hWndDateTime) 
	}
	_ShowDateTime(bShow, offsetTop)
	{

		this.dtPicker.Move(125 * _app.m, offsetTop)
		this.dtPicker.Control("", bShow ? "Show" : "Hide")
	}
	DoModal(setting)
	{
		this.setting := setting
		if (this.setting.fetcher_check_time = 2 && this.setting.fetcher_datetime)
		{
			date := this.setting.fetcher_datetime
		}
		else 
		{
			date := A_Year A_MM A_DD "000000"
		}	
		GuiControl, , % this.dtPicker.hwnd, %date%
		this.ie.Init(JSON.Dump(this.setting))
		return base.DoModal()
	}
	ApplyChange()
	{
		data := this.ie.Submit()
		setting := JSON.Load(data)
		err := ""
		if (setting.chrome_debugging_port < 1024 || setting.chrome_debuggin_port > 65535)
		{
			err .= "디버거포트는 1024 ~ 65535 범위내에서만 설정가능합니다."
		}
		if (err)
		{
			MsgBox, 0x10, 입력오류, %err%
			return false
		}
		if (setting.fetcher_check_time = 2)
		{
			GuiControlGet, date, , % this.dtPicker.hwnd
			setting.fetcher_datetime := date
		}
		this.setting := setting
		return true
	}	
}
class CExchangeInfoDialog extends CModalDialog
{
	__New(g, c)
	{
		html = 
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
html{width:100`%;height:100`%; font-size :1em}
body {margin:0;padding:0;overflow: hidden;font-size: 0.75rem; background-color:#F0F0F0;width:100`%;height:100`%;}
table{width:100`%;height:100`%; border-spacing:0}
td{font-size:0.75rem;}
.setting td:nth-child(1) {width: 40`%; text-align: center;}
.setting td:nth-child(2) {padding-left:1.25rem}
.setting input, select{ border-radius: 0.2rem; border : 1px solid #ADADAD}
.setting input[type=text] {width:7.5rem; text-align:left;}
.setting input[type=button] {background-color:#E1E1E1;width:5em;height:1.563rem; }
td.title{color:red}
</style>
<script>
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function SelectOption(id, value)
{
	for (var i = 0; i < document.getElementById(id).options.length; i++)
	{
		if (document.getElementById(id).options[i].innerText == value)
		{
			document.getElementById(id).selectedIndex = i;
			break
		}		
	}
	document.getElementById(id).addEventListener("change", OnComboChange)
}
function Init(giftcard, issued_company,  phone_number)
{
	document.getElementById("giftcard").innerText = giftcard;
	if (issued_company)
	{
		SelectOption("issued_company", issued_company);
	}
	if (phone_number)
	{
		document.getElementById("phone_number").value = phone_number;
	}
	OnComboChange(null);
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
}
function OnComboChange(e)
{
	c = document.getElementById("issued_company").value;
	g = document.getElementById("giftcard").innerText;
	document.getElementById("phone_display").style.display = ((g == "해피머니" && c == "기프티콘") || g == "컬쳐랜드") ? "" : "none";
}
function Submit()
{
	return {
	"issued_company" : document.getElementById("issued_company").options[document.getElementById("issued_company").selectedIndex].innerText, 
	"phone_number" : document.getElementById("phone_number").value
	};
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td colspan=2 class=title> 필수정보를 찾을수 없습니다. <br>맞게 선택(입력) 해주세요.</td>
  </tr>
  <tr>
    <td>교환대상</td>
	<td><span id=giftcard></span></td>
  </tr>
  <tr>
    <td>발행회사</td>
	<td><select id=issued_company><option>기프티콘</option><option>아이넘버</option><option>기프티쇼</option><option>기프트팝</option></select></td>
  </tr>
  <tr id=phone_display>
    <td>수신번호</td>
	<td> <input type=text maxlength=11 id=phone_number></td>
  </tr>
  <tr>
	<td colspan=2 class=bottom> 
	   	   <input type=button class=button value="취 소">&nbsp;
			<input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)
		base.__New(html, 250, 200, "추가정보확인")
		this.issued_company := c
		this.giftcard := g
		name := _app.name
		RegRead, phone_number , HKEY_CURRENT_USER\Software\DDART\%name%, PhoneNumber
		this.phone_number := phone_number
	}
	__Delete()
	{
		if (this.phone_number)
		{
			name := _app.name
			RegWrite, REG_SZ, HKEY_CURRENT_USER\Software\DDART\%name%, PhoneNumber, % this.phone_number
		}
	}
	DoModal()
	{
		this.ie.Init(this.giftcard, this.issued_company, this.phone_number)
		return base.DoModal()
	}
	ApplyChange()
	{
		ret := this.ie.Submit()
		this.issued_company := ret.issued_company
		if (this.giftcard = "컬쳐랜드" || (this.giftcard = "해피머니" && this.issued_company = "기프티콘"))
		{
			pn := RegExReplace(ret.phone_number, "[^\d]")
			if (StrLen(pn) != 11 && StrLen(pn) != 10)
			{
				MsgBox, 0x10, 입력오류, 전화번호 길이가 맞지않습니다.
				return false
			}
			this.phone_number := pn
		}
		return true
	}
}	
class CIssuedDateDialog extends CModalDialog
{
	__New()
	{
		html = 
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
html{width:100`%;height:100`%; font-size :1em}
body {margin:0;padding:0;overflow: hidden;font-size: 0.75rem; background-color:#F0F0F0;width:100`%;height:100`%;}
table{width:100`%;height:100`%; border-spacing:0}
td{font-size:0.75rem;}
.setting td:nth-child(1) {width: 40`%; text-align: center}
.setting td:nth-child(2) {padding-left:1.25rem}
.setting input, select{ border-radius: 0.2rem; border : 1px solid #ADADAD}
.setting input[type=text] {width:7.5rem; text-align:left;}
.setting input[type=button] {background-color:#E1E1E1;width:5em;height:1.563rem; }
td.title{color:red}
</style>
<script>
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e)
	}
}
function Init(issued_date)
{
	document.getElementById("issued_date").innerText = issued_date;
	var elms = document.getElementsByClassName("button");
	for (var i=0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", EventHandler);
	}
}
function Submit()
{
	return document.getElementById("issued_date").value;
}
</script>
</head>
<body>
<table class=setting>
  <tr>
    <td colspan=2 class=title> 발행일자를 찾을 수 없습니다.<br> 직접 입력해주세요</td>
  </tr>
  <tr>
    <td>발행일자</td>
	<td> <input type=text maxlength=8 id=issued_date></td>
  </tr>
  <tr>
	<td colspan=2 class=bottom> 
	   	   <input type=button class=button value="취 소">&nbsp;
			<input type=button class=button value="확 인">
	</td>
  </tr>
</table>
</body>
</html>
)
		base.__New(html, 250, 150, "추가정보확인")
		name := _app.name
		RegRead, var , HKEY_CURRENT_USER\Software\DDART\%name%, IssuedDate
		this.issued_date := var
	}
	__Delete()
	{
		if (this.issued_date)
		{
			name := _app.name
			RegWrite, REG_SZ, HKEY_CURRENT_USER\Software\DDART\%name%, IssuedDate, % this.issued_date
		}
	}
	DoModal()
	{
		this.ie.Init(this.issued_date)
		return base.DoModal()
	}
	ApplyChange()
	{
		n := RegExReplace(this.ie.Submit(), "[^\d]")
		if (StrLen(n) != 8)
		{
			MsgBox, 0x10, 입력오류, 발행일자길이가 맞지않습니다.
			return false
		}
		this.issued_date := n
		return true
	}
}	







;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COM support & helper classes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
vt(p,n)
{
	return NumGet(NumGet(p+0,"ptr")+n*A_PtrSize,"ptr")
}
_Error(a,b)
{
	static err:={0x8000FFFF:"Catastrophic failure error.",0x80004001:"Not implemented error.",0x8007000E:"Out of memory error.",0x80070057:"One or more arguments are not valid error.",0x80004002:"Interface not supported error.",0x80004003:"Pointer not valid error.",0x80070006:"Handle not valid error.",0x80004004:"Operation aborted error.",0x80004005:"Unspecified error.",0x80070005:"General access denied error.",0x800401E5:"The object identified by this moniker could not be found."
		,0x80040201:"UIA_E_ELEMENTNOTAVAILABLE",0x80040200:"UIA_E_ELEMENTNOTENABLED",0x80131509:"UIA_E_INVALIDOPERATION",0x80040202:"UIA_E_NOCLICKABLEPOINT",0x80040204:"UIA_E_NOTSUPPORTED",0x80040203:"UIA_E_PROXYASSEMBLYNOTLOADED"} ; //not completed
	if a && (a&=0xFFFFFFFF)
	return a
}
class CCOMInterface
{
	__New(pi)
	{
		this.pi := pi
	}
	__Delete()
	{
		if (this.pi)
		{
			ObjRelease(this.pi)
		}
	}
}
class CIOleInPlaceActiveObject extends CCOMInterface
{
	__New(obj)
	{
		this.iid := "{00000117-0000-0000-C000-000000000046}"
		base.__New(ComObjQuery(obj, this.iid))
	}
	TranslateAccelerator(pMsg)
	{
		_Error(DllCall(vt(this.pi, 5),"ptr",this.pi,"ptr",pMsg), A_ThisFunc)
	}
}
class CCUIAutomation extends CCOMInterface
{
	__New()
	{
		this.clsid := "{ff48dba4-60ef-4201-aa87-54103eef594e}"
		this.iid := "{30cbe57d-d9d0-452a-ab13-7ac5ac4825ee}"
		base.__New(ComObjCreate(this.clsid, this.iid))
	}
	ElementFromHandle(hWnd)
	{
		_Error(DllCall(vt(this.pi, 6),"ptr",this.pi,"ptr",hWnd,"ptr*",element), A_ThisFunc)
		return element
	}
	CreateTrueCondition()
	{
		_Error(DllCall(vt(this.pi, 21),"ptr",this.pi,"ptr*",newCondition), A_ThisFunc)
		return newCondition
	}
}
class CIUIAutomationElement extends CCOMInterface
{
	FindAll(scope, condition)
	{
		_Error(DllCall(vt(this.pi, 6),"ptr",this.pi,"int",scope,"ptr",condition,"ptr*",found), A_ThisFunc)
		return found
	}
	GetControlPattern(patternId)
	{
		_Error(DllCall(vt(this.pi,16),"ptr",this.pi,"int",patternId,"ptr*",patternObject), A_ThisFunc)
		return patternObject
	}
	CurrentControlType()
	{
		_Error(DllCall(vt(this.pi,21),"ptr",this.pi,"uint*", type), A_ThisFunc)
		return type
	}
	CurrentName()
	{
		_Error(DllCall(vt(this.pi, 23),"ptr",this.pi,"ptr*",retVal), A_ThisFunc)
		return StrGet(retVal,"utf-16")
	}
}
class CIUIAutomationElementArray extends CCOMInterface
{
	GetLength()
	{
		_Error(DllCall(vt(this.pi, 3),"ptr",this.pi,"int*",length), A_ThisFunc)
		return length
	}
	GetElement(index)
	{
		_Error(DllCall(vt(this.pi, 4),"ptr",this.pi,"int",index,"ptr*",element), A_ThisFunc)
		return element
	}
}
class CIUIAutomationScrollPattern extends CCOMInterface
{
	Scroll(horizontalAmount,verticalAmount)
	{
		return _Error(DllCall(vt(this.pi,3),"ptr",this.pi,"int",horizontalAmount,"int",verticalAmount), A_ThisFunc)
	}
	SetScrollPercent(horizontalPercent,verticalPercent)
	{
		return _Error(DllCall(vt(this.pi,4),"ptr",this.pi,"double",horizontalPercent,"double",verticalPercent), A_ThisFunc)
	}
	CurrentVerticalViewSize()
	{
		_Error(DllCall(vt(this.pi,8),"ptr",this.pi,"double*",retVal), A_ThisFunc)
		return retVal
	}
}
class CHTTP
{
	__New()
	{
		this.http := ComObjCreate(A_OSVersion = "WIN_7" ? "Msxml2.XMLHTTP" : "WinHttp.WinHttpRequest.5.1")
	}
	__Delete()
	{
		if (this.http)
		{
			ObjRelease(this.http)
		}
	}
	Win7WinHttpTLS12Support()
	{
		; WIN_7 에서 WinHttp.WinHttpRequest.5.1로 httprequest 할 경우 TLS 1.2 보안채널 사용하게 하기위한 코드 백업. 
		; TLS 1.2 미만은 최신 서버, 브라우저들에서 더이상 사용되지 않는데 win 7 winhttp에선 tls 1.2가 default 로 사용되지 않는다.
		; 아래 레지스트리작업을 위해서는 관리자권한을 사용자에게 요구해야하므로 아래 코드를 쓰지않고 Msxml2.XMLHTTP 로 대체해서 해결함. 
		if (A_OSVersion != "WIN_7")
			return
		RegRead, DefaultSecureProtocols, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp, DefaultSecureProtocols
		if !(DefaultSecureProtocols & 0x800)
		{
			if (A_IsAdmin)
			{
				commandLine := DllCall("GetCommandLine", "str")
				isRestarted := !!RegExMatch(commandLine, " /restart(?!\S)")
				if (A_Is64bitOS)
				{
					RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp, DefaultSecureProtocols, 0xA00
				}
				RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp, DefaultSecureProtocols, 0xA00
				if (isRestarted)
				{
					MsgBox, 레지스트리값을 설정완료후 프로그램을 종료합니다. 일반권한으로 자동입력기를 다시 실행해주세요.
					ExitApp
				}
			}
			else 
			{
				MsgBox, 4, 자동입력기, 윈도우 7 에서 HTTPS TLS 1.2 사용관련 레지스트리값을 설정합니다. 지금 관리자권한으로 자동 설정하시겠습니까?, 30
				IfMsgBox, Yes
				{
					MsgBox, 관리자권한으로 다시 실행합니다. 실행 후 곧바로 도움말->업데이트 확인을 해주셔야 설정이 완료됩니다.
					if A_IsCompiled
						Run *RunAs "%A_ScriptFullPath%" /restart
					else
						Run *RunAs "%A_AhkPath%" /restart "%A_ScriptFullPath%"
					ExitApp
				}
				else
				{
					MsgBox, 직접 HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings\WinHttp아래에 DWORD키 DefaultSecureProtocols의 값을 16진수 A00 (10진수 2560) 으로 생성 혹은 설정해주세요.
				}
			}
		}
	}
	Get(url)
	{
		try
		{
			this.http.open("GET", url, False)
			if (A_OSVersion = "WIN_7")
			{
				; Msxml2.XMLHTTP 에서는 max-age=0 가 안 먹힘.
				this.http.setRequestHeader("Pragma", "no-cache")
				this.http.setRequestHeader("Cache-Control", "no-cache, no-store")
				this.http.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT")
			}
			else
			{
				this.http.setRequestHeader("Cache-Control", "max-age=0")
			}
			this.http.Send()
			return this.http.responseText
		}
		catch e
		{
		}
		return ""
	}
}
class CHtmlUtil
{
	__New()
	{
		Gui, Add, ActiveX, hWndhWndHtmlUtill hidden, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		this.wb := WBGet("ahk_id " hWndHtmlUtill)
		this.wb.document.open()
		this.wb.document.write("")
		this.wb.document.close()
	}
	Escape(str)
	{
		return this.wb.document.parentWindow.escape(str)
	}
	Unescape(str)
	{
		return this.wb.document.parentWindow.unescape(str)
	}
	ReplaceHtmlSpeicalChars(str)
	{
		this.wb.document.body.innerHTML := str
		return this.wb.document.body.innerText
	}	
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Chrome 기반 브라우저 지원 클래스들
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CChrome
{
	__New()
	{
		this.port := 9222
		this.id := 1
		this.exename := "chrome"
		this.lnkname := "Chrome"
		this.korname := "크롬"
		this.titlesuffix := "Chrome"
		this.html := new CHtmlUtil()
	}
	Unescape(value)
	{
		return this.html.Unescape(value)
	}
	Launch(port := 9222)
	{
		exe := this.exename
		lnk := this.lnkname
		RegRead, path, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\%exe%.exe
		if (!path)
		{
			FileGetShortcut, %A_StartMenuCommon%\Programs\%lnk%.lnk, path
			if (!path)
			{
				FileGetShortcut, %A_StartMenu%\Programs\%lnk%.lnk, path
			}
		}
		if (FileExist(path))
		{
			this.path := path
		}
		else
		{
			MsgBox, , %lnk% Error, "설치된 경로를 찾을수 없습니다"
			return
		}
		target := this.path " --remote-debugging-port=" port " --user-data-dir=""" A_ScriptDir "\" exe "profile_autocoder"""
		Run, %target%
		this.port := port
		Loop, 10
		{
			Sleep, 200
			if (this.IsExist())
			{
				break
			}
		}
	}
	IsExist()
	{
		for proc in ComObjGet("winmgmts:").ExecQuery("Select * from Win32_Process where name='" this.exename ".exe'")
		{
			if (InStr(proc.CommandLine, "--remote-debugging-port=" this.port " --user-data-dir"))
			{
				return WinExist("ahk_pid " proc.ProcessId)
			}
		}
		return false
	}
	GetWebSocketUrl(value, byUrl := false)
	{
		; 크롬 디버거용 로컬서버에서 디버깅주소가져오기임. 모두 로컬주소로 외부서버로 나가는 일 없음
		http := new CHTTP()
		list := JSON.Load(http.Get("http://127.0.0.1:" this.port "/json/list"))
		if (!list)
		{
			return -1
		}
		Loop, % list.MaxIndex()
		{
			if (byUrl)
			{
				if (InStr(list[A_Index].url, value))
				{
					return list[A_Index].webSocketDebuggerUrl
				}
			}
			else if (this.html.ReplaceHtmlSpeicalChars(list[A_Index].title) = value)
			{
				return list[A_Index].webSocketDebuggerUrl
			}
		}
		return ""
	}
}
class CMicrosoftEdge extends CChrome
{
	__New()
	{
		base.__New()
		this.id := 2
		this.exename := "msedge"
		this.lnkname := "Microsoft Edge"
		this.korname := "엣지"
		this.titlesuffix := "개인 - Microsoft​ Edge"
	}
}
class CNaverWhale extends CChrome
{
	__New()
	{
		base.__New()
		this.id := 3
		this.exename := "whale"
		this.lnkname := "네이버 웨일"
		this.korname := "웨일"
		this.titlesuffix := "Whale"
	}
}
class CWebSocket extends CWindow
{
	; 크롬 로컬 디버거 서버랑 WebSocket통신을 하기위한 용도로 익스플로러 ActiveX를 하는 호스팅하는 것임
	; 데이터교환흐름 AHK자동입력기<->익스플로러 로컬페이지<->크롬 로컬디버거서버
	__New(url)
	{
		static id := 0
		this.url := url
		guiname := "WebSocket" id++
		this.guiname := guiname
		
		Gui, %guiname%:+Owner1 +hWndhWnd
		Gui, %guiname%:Add, ActiveX, hWndhWndAX, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=edge'>
		Sleep, 100
		wb := WBGet("ahk_id " hWndAX)
		base.__New(hWnd)
		html =
(
<script>
var ws = null;
function Init(url)
{
	ws = new WebSocket(url);
	ws.onopen = EventHandler;
	ws.onclose = EventHandler;
	ws.onerror = EventHandler;
	ws.onmessage = EventHandler;
}
function EventHandler(e)
{
	if (_EventHandler)
	{
		_EventHandler(e);
	}
}
</script>
)
		wb.document.open()
		wb.document.write(html)
		wb.document.close()
		this.ie := wb.document.parentWindow
		this.ie._EventHandler := this._EventHandler.Bind(this)
		this.ie.Init(url)
	}
	__Delete()
	{
		this.ie := ""
		this.wb := ""
	}
	_EventHandler(e)
	{
		if (this["On" e.type])
		{
			this["On" e.type](e)
		}
	}
	Send(data)
	{
		this.ie.ws.send(data)
	}
	Close(code:=1000, reason:="")
	{
		this.ie.ws.close(code, reason)
	}
	Destroy()
	{
		this.ie._EventHandler := ""
		guiname := this.guiname
		Gui, %guiname%:Destroy
	}	
}
class CChromeWSClient extends CWebSocket
{
	__New(url)
	{
		this.boolean_false := {boolean : false}
		this.boolean_true := {boolean : true}
		this.bConnected := false
		this.responses := Array()
		this.fnPing := this.Ping.Bind(this)
		base.__New(url)
		Loop, 20
		{
			if (this.bConnected)
			{
				break
			}
			Sleep, 50
		}
	}
	__Delete()
	{
		base.__Delete()
	}
	Call(method, params:="", bWait := true)
	{
		if (!this.bConnected)
		{
			return ""
		}
		id := 1
		if (this.responses.MaxIndex())
		{
			id := this.responses.MaxIndex() + 1
		}
		data := Object()
		data.id := id
		data.method := method
		if (params)
		{
			data.params := params
		}
		datastr := StrReplace(StrReplace(JSON.Dump(data), "{""boolean"":0}", "false"), "{""boolean"":1}", "true")
		this.Send(datastr)
		if (!bWait)
		{
			return
		}
		this.responses[id] := false
		Loop, 100
		{
			if (this.responses[id])
				break
			sleep, 50
		}
		response := this.responses.Delete(id)
		if (response)
		{
			if (response.error)
			{
			}
			;LogMessage("Response: " JSON.Dump(response))
			return response.result
		}
		return ""
	}
	HandleJavaScriptDialog(accept := true)
	{
		params := {}
		params.accept := accept ? this.boolean_true : this.boolean_false
		response := this.Call("Page.handleJavaScriptDialog", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.result
		
	}
	Navigate(url)
	{
		params := {}
		params.url := url
		response := this.Call("Page.navigate", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.frameId
		
	}
	Evaluate(expression)
	{
		params := {}
		params.expression := expression
		params.objectGroup := "console"
		params.includeCommandLineAPI := this.boolean_true
		params.silent := this.boolean_false
		params.returnByValue := this.boolean_false
		params.userGesture := this.boolean_true
		params.awaitPromise := this.boolean_false
		response := this.Call("Runtime.evaluate", params)
		if (response.exceptionDetails)
		{
			return ""
		}
		return response.result
	}
	Ping()
	{
		this.Call("Browser.getVersion", "",false)
	}
	GetVersion()
	{
		return this.Call("Browser.getVersion")
	}
	OnOpen(e)
	{
		this.bConnected := true
		ping := this.fnPing
		SetTimer, %ping%, 15000
	}
	OnMessage(e)
	{
		data := JSON.Load(e.data)
		if (this.responses.HasKey(data.id))
		{
			this.responses[data.id] := data
		}
	}
	OnClose(e)
	{
		this.Destroy()
		this.bConnected := false
		ping := this.fnPing
		SetTimer, %ping%,  Delete
		; 반드시 지워야 클래스오브젝트가 릴리스됨.
		this.fnPing := ""
		this.ie.ws := ""
		_app.PostMessage(_app.WM_WEBSOCKET_DISCONNECTED, 0, 0)
	}
	OnError(e)
	{
	}
	Disconnect()
	{
		if (this.bConnected)
			base.Close()
		Loop, 20
		{
			if (!this.bConnected)
				break
			Sleep, 50
		}
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Webbrowser classes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CWebBrowser extends CWindow
{
	__New(n, h, l := "", c := "")
	{
		this.wb := ""
		this.name := n
		this.homepage_url := h
		this.login_url := h l
		this.charging_url := h c
	}
	SetChargingUrl(url)
	{
		this.charging_url :=  this.homepage_url url
	}
	SetPageError()
	{
		this.err .= "활성화된 '" this.name "' 페이지를 찾을수 없습니다. `r`n"
		this.err .= this.name " 로그인 페이지로 이동합니다. 로그인 후 다시 실행을 눌러주세요"
	}
	SetHWnd(hwnd)
	{
		this.hwnd := hwnd
		this.title := "ahk_id " hwnd
		return WinExist(this.title)
	}
	GetDomain(url)
	{
		if (RegExMatch(url, "O)\/\/([\w\.]+)", matches))
		{
			return matches[1]
		}
		return ""
	}
}
class CWBInternetExplorer extends CWebBrowser
{
	__Delete()
	{
		this.wb := ""
	}
	GetBrowserInfo()
	{
		return this.wb.document.parentWindow.navigator.userAgent
	}
	Init()
	{
		this.err := ""
		if (!this.SetHWnd(WinExist("ahk_class IEFrame")))
		{
			this.err .= "인터넷 익스플로러가 실행중이지 않습니다`r`n"
			this.SetPageError()
			wb := ComObjCreate("InternetExplorer.Application")
			wb.Visible := true
			wb.Navigate(this.login_url)
			ObjRelease(wb)
			return false
		}
		this.wb := WBGet()
		if (this.wb)
		{
			try
			{
				this.WaitComplete()
			}
			catch e
			{
				this.err := "웹브라우저 컨트롤 오류 : " e.message "`r`n"
				this.err .= "회복할수 없는 오류이니 IE 브라우저를 종료후 다시 실행해주세요"
				this.wb := ""
				return false
			}
			return true
		}
		this.err := "IWebBrowserApp Com Object를 가져올 수 없습니다. `r`n"
		this.err .= "회복할수 없는 오류이니 IE 브라우저를 종료후 다시 실행해주세요"
		return false
	}
	WaitComplete()
	{
		Loop, 50
		{
			Sleep, 200
			if (this.wb.document.readyState = "complete")
			{
				return true
			}
		}
		return false
	}
	GotoUrl(url)
	{
		this.Activate()
		current_url := SubStr(this.wb.document.location.href, 6)
		if (InStr(url, current_url))
		{
			this.wb.document.location.reload(false)
			return this.WaitComplete()
		}
		this.ControlSetText("Edit1", url)
		Sleep, 200
		this.ControlSend("Edit1", "{Enter}")
		Sleep, 500
		this.WaitComplete()
		Loop, 10
		{
			current_url := SubStr(this.wb.document.location.href, 6)
			if (InStr(url, current_url))
			{
				return true
			}
			else
			{

				this.wb := WBGet()
			}
		}
		return false
	}
	
	CheckState()
	{
		this.err := ""
		if (!InStr(this.wb.document.location.href, this.GetDomain(this.homepage_url)))
		{
			this.SetPageError()
			this.win := new CWindow(WinExist("ahk_class IEFrame"))
			title := this.win.GetTitle()
			if (title != "빈 페이지 - Internet Explorer" && title != "새 탭 - Internet Explorer")
			{
				; 새 탭 열기
				Send, ^t
				Loop, 20
				{
					Sleep, 200
					if (this.win.GetTitle() = "새 탭 - Internet Explorer")
					{
						break
					}
					else
					{
					}
				}
				Sleep, 1000
			}
			if (!this.GotoUrl(this.login_url))
			{
				; WB 재설정 해줌
				this.wb := ""
				return false
			}
		}
		return true
	}
}
class CWBChrome extends CWebBrowser
{
	__Delete()
	{
		if (this.wb)
		{
			this.wb.Disconnect()
		}
		this.wb := ""
	}
	Unescape(value)
	{
		return _app.chrome.Unescape(value)
	}
	GetBrowserInfo()
	{
		result := this.wb.GetVersion()
		return result.userAgent
	}
	Init(bLaunch := true)
	{
		this.err := ""
		name := _app.chrome.korname
		if (!this.SetHWnd(_app.chrome.IsExist()) && bLaunch)
		{
			this.err := "개발자모드로 실행된 " name "창이 존재하지 않습니다. " name "을 개발자모드로 실행합니다. `r`n"
			_app.OnChromeLaunch()
			Loop, 40
			{
				Sleep, 250
				if (this.SetHWnd(_app.chrome.IsExist()))
				{
					break
				}
			}
		}
		if (!this.Exist())
		{
			this.err .= "개발자모드로 실행된 " name "창이 존재하지 않습니다"
			return false
		}
		if (!this.InitWSClient())
		{
			return false
		}		
		this.Activate()
		return true
	}
	OpenNewTab()
	{
		; 새 탭 열기
		this.wb.Disconnect()
		this.wb := ""
		Send, ^t
		url := this.GetWebSocketUrl("새 탭")
		if (url)
		{
			this.wb := new CChromeWSClient(url)
		}
	}
	GetWebSocketUrl(title)
	{
		Loop, 10
		{
			Sleep, 100
			url := _app.chrome.GetWebSocketUrl(title)
			if (url)
			{
				return url
			}
		}
		return ""
	}
	InitWSClient()
	{
		if (this.homepage_url)
		{
			url := _app.chrome.GetWebSocketUrl(this.homepage_url, true)
		}
		if (!url)
		{
			title := this.GetTitle()
			if (RegExMatch(title, " - " _app.chrome.titlesuffix "$"))
			{
				title := RegExReplace(title, " - " _app.chrome.titlesuffix "$")
			}
			else
			{
				title := RegExReplace(title, " - .+$")
			}
			url := _app.chrome.GetWebSocketUrl(title)
		}
		if (url = -1)
		{
			this.err := _app.chrome.korname " DevTool의 /json/list 엔드포인트에 연결할수 없습니다."
			return false
		}
		else if (!url)
		{
			this.err := "현재 창에 대한 디버깅주소를 못찾음"
			return false
		}
		if (this.wb)
		{
			if (this.wb.url != url || !this.wb.bConnected)
			{
				this.wb.Disconnect()
				this.wb := new CChromeWSClient(url)
			}
		}
		else
		{
			this.wb := new CChromeWSClient(url)
		}
		return true
	}
	CheckState()
	{
		result := this.wb.Evaluate("document.location.href")
		this.err := ""
		if (!InStr(result.value, this.GetDomain(this.homepage_url)))
		{
			this.SetPageError()
			if (!InStr(this.GetTitle(),"새 탭"))
			{
				this.OpenNewTab()
			}
			if (!this.GotoUrl(this.login_url))
			{
				this.err .= "새탭을 못엶. 다시 실행시도해주세요"
			}
		}
		return true
	}
	GotoUrl(url)
	{
		if (!this.wb)
		{
			return false
		}
		result := this.wb.Navigate(url)
		if (result)
		{
			if (this.WaitComplete())
			{
				return true
			}
		}
		return false
	}
	WaitTitle(title)
	{
		Loop, 10
		{
			Sleep, 500
			if (InStr(this.GetTitle(), title))
			{
				this.WaitComplete()
				return true
			}
		}
		return false
	}
	WaitComplete()
	{
		Loop, 40
		{
			Sleep, 250
			result := this.wb.Evaluate("document.readyState")
			if (result && result.value = "complete")
			{
				return true
			}
		}
		return false
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GiftCode class
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CGiftCode
{
	codes := Object()
	__New(b, n, r, h, l, c, p := 10)
	{
		this.browser := b
		this.name := n
		this.regex := r
		this.win := b ? new CWBChrome(n, h, l, c) : new CWBInternetExplorer(n, h, l, c)
		this.npp := p
		this.npp_default := p
		this.issued_date := 0
		this.exchange := false
		this.issued_company := 0
		this.phone_number := ""
		this.exchange_urls := Object()
	}
	ArrangeCode()
	{
	}
	ArrangeExCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (StrLen(codes) = 12)
			{
				if (this.name = "해피머니" && this.issued_company = "기프티콘")
				{
					arr.Push(Array(codes, this.phone_number))
				}
				else
				{
					arr.Push(Array(codes))
				}
			}
		}
		this.codes := arr
	}
	AutoInput()
	{
		return false
	}
	AutoInputEx()
	{
		if (this.codes.MaxIndex() = 0)
		{
			this.err := "선택된 상품권이 하나도 없습니다. 다시 선택해주세요"
			return false
		}
		if (this.exchange)
		{
			Loop, % this.npp
			{
				row := A_Index + this.page_base
				if (row > this.codes.MaxIndex())
				{
					break
				}
				if (this.GotoCharging())
				{
					if (_app.setting.ex_charging_interval)
					{
						_app.AppendLog(Format("{1:.2f}", _app.setting.ex_charging_interval/1000)  " 초간 쉽니다.")
						Sleep, % _app.setting.ex_charging_interval
					}
				}
				else
				{
					return false
				}
				if (!this.AutoExchangeInput(row))
				{
					return false
				}
			}
			return true
		}
		else
		{
			return this.GotoCharging() && this.AutoInput()
		}
	}
	AutoExchangeInput(row)
	{
		return false
	}
	ConfirmExchangeErrorGoNext(row)
	{
		_app.AppendLog("교환에 실패했습니다.")
		if (row < this.codes.MaxIndex())
		{
			MsgBox, 4, 자동입력기, 교환권 교환에 실패했습니다. 그래도 다음번호로 계속 진행하시겠습니까?, 30
			IfMsgBox, Yes
			{
				return true
			}
			return false
		}				
		return true
	}
	GetBrowserInfo()
	{
		return this.win.GetBrowserInfo()
	}
	GetName()
	{
		name := this.name
		if (this.exchange)
		{
			name .= " " this.issued_company
		}
		else
		{
			name .= " 상품권"
		}
		return name
	}
	GetNumberOnly(str)
	{
		return RegExReplace(str, "[^\d]")
	}
	GetError()
	{
		err := this.err 
		if (this.win.err)
		{
			err .= "`r`n" this.win.err
		}
		this.err := ""
		this.win.err := ""
		return err
	}
	GetExchangeInfo(ByRef content)
	{
		regexp := "Oi)(기프티쇼|기프티콘|기프트팝|아이넘버|giftishow|gifticon|giftpop|inumber)"
		if (RegExMatch(content, regexp, matches))
		{
			cnames_ko := ["기프티쇼", "기프티콘", "기프트팝", "아이넘버"]
			cnames_en := ["giftishow", "gifticon", "giftpop", "inumber"]
			this.issued_company := matches[1]
			Loop, % cnames_en.MaxIndex()
			{
				if (this.issued_company = cnames_en[A_Index])
				{
					this.issued_company := cnames_ko[A_Index] 
					break
				}
			}
		}
		if (RegExMatch(content, "O)수신.*(01[\d\-]{9,})", matches))
		{
			this.phone_number := SubStr(RegExReplace(matches[1], "-"), 1, 11)
		}
		if (!this.issued_company && !this.GetUserInputExchangeInfo())
		{
			return false
		}
		if ((this.name = "컬쳐랜드" || (this.name = "해피머니" && this.issued_company = "기프티콘")) && ! this.phone_number && !this.GetUserInputExchangeInfo())
		{
			return false
		}
		url := this.exchange_urls[this.issued_company]
		if (url)
		{
			this.win.SetChargingUrl(url)
		}
		else
		{
			this.err := this.issued_company " 의 " this.name " 교환권은 지원하지 않습니다."
			return false
		}
		return true
	}
	GetCode(row)
	{
		if (this.codes[row])
		{
			Loop, % this.codes[row].MaxIndex()
			{
				code .= this.codes[row][A_Index] "-"
			}
			StringTrimRight, code, code, 1
			return code
		}
		return 0
	}
	GetCurrentPageInfo()
	{
		return "다음 실행될 페이지는 " this.page " / " this.total_page " 페이지입니다"	
	}
	GetRowCountPrefix(row)
	{
		max_len := StrLen(this.codes.MaxIndex())
		prefix := "0000"
		return SubStr(prefix, 1, max_len - StrLen(row)) row "/" this.codes.MaxIndex() " : "
	}
	GetUserInputExchangeInfo()
	{
		dlg := new CExchangeInfoDialog(this.name, this.issued_company)
		if (dlg.DoModal())
		{
			if (!this.issued_company)
			{
				_app.editContent.AppendText("`r`n`r`n발행회사 : "  dlg.issued_company "`r`n")
			}
			if (!this.phone_number && dlg.phone_number)
			{
				_app.editContent.AppendText("`r`n수신 : " dlg.phone_number "`r`n")
			}
			this.issued_company := dlg.issued_company
			this.phone_number := dlg.phone_number
			return true
		}
		this.err := "필요한 정보입력을 취소하였습니다"
		return false
	}
	GetUserInputIssuedDate()
	{
		dlg := new CIssuedDateDialog()
		if (dlg.DoModal())
		{
			_app.editContent.AppendText("`r`n`r`n발행일 : "  dlg.issued_date "`r`n")
			this.issued_date := dlg.issued_date
			return true
		}
		this.err := "필요한 정보입력을 취소하였습니다"
		return false
	}	
	GotoCharging()
	{
		_app.ExitIfStop()
		this.err := ""
		if (!this.win.GotoUrl(this.win.charging_url))
		{
			this.err := "충전페이지 이동에 실패했습니다"
			return false
		}
		this.win.Activate()
		Sleep, 1000
		return true
	}
	InitWebBrowser()
	{
		if (this.win.Init())
		{
			this.win.Activate()
			this.win.Move(0, 0)
			this.err := "로그인 해주세요"
			return this.win.CheckState() && this.IsLogined()
		}
		return false
	}
	IsLogined()
	{
		return false
	}
	Load()
	{
		if (!this.view.bItemChanged)
		{
			return true
		}
		this.view.Activate()
		if (this.view.GetCount("S") = 0)
		{
			this.err := "선택된 상품권이 하나도 없습니다"
			return false
		}
		names := StrSplit(this.view.name, " ")
		this.name := names[1]
		this.exchange := (names[2] != "상품권")
		if (this.exchange)
		{
			this.issued_company := names[2]
			this.win.SetChargingUrl(this.exchange_urls[this.issued_company])
			this.npp_default := _app.setting.ex_charging_auto ? 10000 : 1
		}
		this.codes := Array()
		this.view.selections := Array()
		row := 0
		while(row := this.view.GetNext(row))
		{
			this.codes.Push(StrSplit(this.view.rows[row][2], "-"))
			this.view.selections.Push(row)
			this.view.SetUsed(row, false)
		}
		this.view.bItemChanged := false
		this.SetPage(1)
		return true
	}
	Parse(ByRef content)
	{
		this.ParseRegex(content)
		this.ArrangeCode()
		if (this.codes.MaxIndex() > 0)
		{
			if (this.name = "해피머니" && this.codes[1][5] = 0)
			{
				if (RegExMatch(content, "O)발행일[^\d]*(20[\d\_\-]{6,})", matches))
				{
					this.issued_date := this.GetNumberOnly(matches[1])
					if (StrLen(this.issued_date) != 8)
					{
						this.issued_date := 0
					}
				}
				else if (RegExMatch(content, "Os)발행일.*(20\d{6})", matches))
				{
					this.issued_date := matches[1]
				}
				if (!this.issued_date && !this.GetUserInputIssuedDate())
				{
					return false
				}
				Loop, % this.codes.MaxIndex()
				{
					this.codes[A_Index][5] := this.issued_date
				}
			}
		}
		else
		{
			this.regex :=  "O)[\s\n\,\:]([\d\-\_]{12,})"
			this.ParseRegex(content)
			if (this.codes.MaxIndex() > 0)
			{
				this.exchange := this.GetExchangeInfo(content)
				if (!this.exchange)
				{
					return false
				}
				this.npp_default := 10000
				this.ArrangeExCode()
			}
		}
		if (this.codes.MaxIndex() < 1)
		{
			if (this.exchange)
			{
				this.err := this.issued_company " " this.name " 교환 쿠폰번호를 하나도 찾을수 없습니다."
			}
			else
			{
				this.err := this.name " 핀번호를 하나도 찾을수 없습니다."
			}
			return false
		}
		this.SetPage(1)
		return true
	}
	ParseRegex(ByRef content)
	{
		pos := 1
		while (pos := RegExMatch(content, this.regex, matches, pos))
		{
			code := matches[1]
			pos += matches.Len(0)
			if (matches.Count() = 3)
			{
				if (matches[2] && !Instr(matches[2], "인증번호"))
				{
					pos -= matches.Len(3)
				}
				else
				{
					code .= matches[3]
				}
			}
			code := this.GetNumberOnly(code)
			this.codes.Push(code)
		}
	}
	Send(row, col, skip := false)
	{
		_app.ExitIfStop()
		if (!skip)
		{
			Sleep, % _app.setting.send_interval
			Send, % this.codes[row][col]
		}
		if (col = this.codes[row].MaxIndex())
		{
			this.SetUsed(row)
		}
		if (_app.setting.skip_send_logging)
		{
			return
		}
		if (col = 1)
		{
			_app.editLog.AppendText(this.GetRowCountPrefix(row))
		}
		_app.editLog.AppendText(this.codes[row][col])
		if (col = this.codes[row].MaxIndex())
		{
			_app.editLog.AppendText("`r`n")
		}
		else
		{
			_app.editLog.AppendText("-")
		}
	}
	SendExchange(row)
	{
		_app.ExitIfStop()
		code := this.codes[row][1]
		_app.editLog.AppendText(this.GetRowCountPrefix(row) code "`r`n")
		Send %code%
	}
	SetInputElementsError()
	{
		this.err := this.name " 입력창의 구성요소를 찾을수 없습니다. 상품권 번호 입력창이 띄워져 있는지 확인하세요"
	}
	SetPage(page)
	{
		this.npp := (this.exchange && !_app.setting.ex_charging_auto) ? 1 : this.npp_default
		this.total_page := Ceil(this.codes.MaxIndex() / this.npp)
		if (page >= 1 && page <= this.total_page)
		{
			this.page := page
			this.page_base := (this.page - 1) * this.npp
			if (this.total_page > 1 && this.view)
			{
				this.view.Activate()
				this.view.Modify(0, "-Select")
				Loop, % this.npp
				{
					row := this.page_base + A_Index
					if (row > this.view.selections.MaxIndex())
					{
						break
					}
					if (A_Index = 1)
					{
						this.view.EnsureVisible(this.view.selections[row] - 1)
					}
					this.view.Modify(this.view.selections[row], "Select")
				}
			}
			return true
		}
		return false
	}
	SetUsed(row)
	{
		this.view.SetUsed(this.view.selections[row])
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Giftcode Companies
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CHappyMoney extends CGiftCode
{
	__New(b)
	{
		base.__New(b, "해피머니", "O)([\d\-\_ ]{16,})", "http://www.happymoney.co.kr", "/svc/login/login.hm", "/svc/cash/giftCardCharge.hm")
		this.exchange_urls["기프티쇼"] := "/svc/card/exchangeCoupon.hm"
		this.exchange_urls["기프티콘"] := "/svc/card/exchangeCoupon.hm"
		this.exchange_urls["기프트팝"] := "/svc/card/exchangeCoupon.hm"
		this.exchange_urls["아이넘버"] := "/svc/card/exchangeCoupon.hm"
	}
	ArrangeCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (StrLen(codes) = 24)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 4), SubStr(codes, 17, 8)))
			}
			else if(StrLen(codes) = 16)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 4), 0))
			}
		}
		this.codes := arr
	}
}
class CBookNLife extends CGiftCode
{
	__New(b)
	{
		base.__New(b, "북앤라이프", "O)([\d\-\_]{16,})([^\d\,]*)(\d{4})", "https://www.booknlife.com", "/hp/login.do", "/hp/payModule/CashChargeBnlVoucher.do", 20)
		this.exchange_urls["기프티콘"] := "/hp/payModule/couponExchangeGifticon.do"
		this.exchange_urls["카카오톡"] := "/hp/payModule/couponExchangeKakao.do"
		this.exchange_urls["기프티쇼"] := "/hp/payModule/couponExchangeGiftishow.do"
		this.exchange_urls["아이넘버"] := "/hp/payModule/couponExchangeInumber.do"
	}
	ArrangeCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (StrLen(codes) = 24)
			{
				codes := SubStr(codes, 1, 20)
			}
			if(StrLen(codes) = 20)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 4), SubStr(codes, 17, 4)))
			}
		}
		this.codes := arr
	}
}
class CCultureLand extends CGiftCode
{
	__New(b)
	{
		base.__New(b, "컬쳐랜드", "O)([\d\-\_ ]{16,})", "http://www.cultureland.co.kr", "/signin/login.do", "/charge/gift/giftVoucher.do")
		; this.exchange_urls["기프티콘"] := "/purchase/exchange/couponSelect.do"
		; 카카오|구글플레이|기프티콘|아이넘버
	}
	ArrangeCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			codes := this.codes[A_Index]
			if (codes = "123412341234123456")
			{
				continue
			}
			if (StrLen(codes) = 18)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 6)))
			}
			else if(StrLen(codes) = 16)
			{
				arr.Push(Array(SubStr(codes, 1, 4), SubStr(codes, 5, 4), SubStr(codes, 9, 4), SubStr(codes, 13, 4)))
			}
		}
		this.codes := arr
	}
}
class CCustomCode extends CGiftCode
{
	__New(name, digits)
	{
		base.__New(0, name, "O)([\d ]{" digits "})", "", "", "")
	}
}
class CSmileCash extends CGiftCode
{
	__New()
	{
		base.__New(0, "스마일캐시", "O)([\d ]{16,})", "", "", "")
	}
	ArrangeCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			arr.Push(Array(this.codes[A_Index]))
		}
		this.codes := arr
	}
}
class CTrueFriend extends CGiftCode
{
	__New()
	{
		base.__New(0, "한국투자증권", "O)(\d{12})", "", "", "")
	}
	ArrangeCode()
	{
		arr := Array()
		Loop, % this.codes.MaxIndex()
		{
			arr.Push(Array(this.codes[A_Index]))
		}
		this.codes := arr
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; AutoInput classes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CHappyMoneyIE extends CHappyMoney
{
	__New()
	{
		base.__New(0)
	}
	IsLogined()
	{
		elm := this.win.wb.document.getElementById("myBoxSub")
		return  (elm && elm.parentElement.style.display = "")
	}
	AutoInput()
	{
		if (!this.win.wb.document.getElementById("layer_1"))
		{
			this.SetInputElementsError()
			return false
		}
		this.win.wb.document.getElementById("layer_1").style.display :="none"
		Sleep, 500
		this.win.wb.document.getElementById("addTen").scrollIntoView(true)
		
		if (this.codes.MaxIndex() - this.page_base > 5 && this.win.wb.document.getElementsByClassName("delTen")[0].style.display != "inline-block")
		{
			this.win.wb.document.getElementById("addTen").click()
		}
		if (this.win.wb.document.getElementsByClassName("csOn").length = 1)
		{
			this.win.wb.document.getElementsByClassName("csOn")[0].click()
		}
		Sleep, 500
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				if (col = 5)
				{
					eid := "issuedDate_" (row - this.page_base)
				}
				else
				{
					eid := "pinNo" col "_" (row - this.page_base)
				}
				this.win.wb.document.getElementById(eid).click()
				this.Send(row, col)
			}
		}
		return true
	}
	AutoExchangeInput(row)
	{
		elements := this.win.wb.document.getElementsByClassName("inDetailBox")
		if (!elements || elements.length < 1)
		{
			this.SetInputElementsError()
			return false
		}
		elements := elements[0].getElementsByTagName("IMG")
		bFound := false
		Loop, % elements.length
		{
			if (elements[A_Index -1].alt = this.issued_company)
			{
				elements[A_Index - 1].click()
				bFound := true
				break
			}
		}
		if (!bFound)
		{
			this.err := "입력페이지에서 " this.issued_company " 요소를 찾을수 없습니다."
			return false
		}
		if (this.issued_company = "기프티콘")
		{
			this.win.wb.document.getElementById("phoneNo").focus()
			Sleep, 200
			Send, % this.codes[row][2]
			this.win.wb.document.getElementById("agreeThisOne").click()
		}
		this.win.wb.document.getElementById("couponNo").focus()
		this.SendExchange(row)
		this.win.wb.document.getElementById("couponRetrieve").click()
		if (!_app.setting.ex_charging_auto)
		{
			return true
		}
		result_msg := this.win.wb.document.getElementsByClassName("payDetail excCoupon")[2].innerText
		if (RegExMatch(result_msg, "가능합니다"))
		{
			charge_btnclass := _app.setting.ex_charging_target ? "hpOnlin" : "hpCash"
			this.win.wb.document.getElementsByClassName(charge_btnclass)[0].getElementsByTagName("A")[0].click()
			Sleep, 200
			result_msg := this.win.wb.document.getElementsByClassName("payDetail excCoupon")[2].innerText
			if (RegExMatch(result_msg, "충전되었습니다|완료되었습니다"))
			{
				this.SetUsed(row)
				_app.editLog.AppendText(result_msg "`r`n")
				if (RegExMatch(result_msg, "O)([\d\-]{16,})", matches))
				{
					_app.AddGiftCode("해피머니 상품권", matches[1] "-" StrReplace(matches[2], "-"))
				}
				return true
			}
			this.err .= "교환이 완료되지 못했습니다"
			return this.ConfirmExchangeErrorGoNext(row)
		}
		else
		{
			this.err .= "확인결과가 유효하지 않습니다.."
			return this.ConfirmExchangeErrorGoNext(row)
		}
		return false
	}
}
class CHappyMoneyCR extends CHappyMoney
{
	__New()
	{
		base.__New(1)
	}
	IsLogined()
	{
		result := this.win.wb.Evaluate("document.getElementById('myBoxSub').parentElement.style.display")
		return (result.value = "")
	}
	AutoInput()
	{
		result := this.win.wb.Evaluate("document.getElementById('addTen')")
		if (result.subtype = "null")
		{
			this.SetInputElementsError()
			return false
		}
		this.win.wb.Evaluate("document.getElementById('layer_1').style.display='none'")
		this.win.wb.Evaluate("document.getElementById('addTen').scrollIntoView(true)")
		result := this.win.wb.Evaluate("document.getElementsByClassName('delTen')[0].style.display")
		if (result.value != "inline-block" && this.codes.MaxIndex() > 5)
		{
			this.win.wb.Evaluate("document.getElementById('addTen').click()")
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('csOn').length")
		if (result.value = 1)
		{
			result := this.win.wb.Evaluate("document.getElementsByClassName('csOn')[0].click()")
		}
		; 해피머니사이트의 TouchEnNxKey 무력화시키기
		disable_tk := "var fn=function(id){ elm = document.getElementById(id); elm.removeEventListener('keydown', TK_KeyDown); elm.removeEventListener('keypress', TK_Keypress); elm.removeEventListener('keyup', TK_Keyup);};for (r=1; r <=10; r++){ for(c=1;c <=4;c++) {  fn('pinNo' + c + '_' + r); } fn('issuedDate_'+r);}"
		result := this.win.wb.Evaluate(disable_tk)
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				if (col = 5)
				{
					eid := "issuedDate_" (row - this.page_base)
				}
				else
				{
					eid := "pinNo" col "_" (row - this.page_base)
				}
				Sleep, 100
				this.win.wb.Evaluate("document.getElementById('" eid "').focus()")
				if (row - this.page_base = 1 && col = 1)
				{
					Sleep, 500
				}
				this.Send(row, col)
			}
		}
		; 마지막 입력 지워지지않게 input 박스의 포커스 없애기
		this.win.wb.Evaluate("document.getElementsByClassName('chargeArea')[0].click()")
		return true
	}
	AutoExchangeInput(row)
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('inDetailBox')[0].getElementsByTagName('IMG').length")
		length := result.value
		if (length < 1)
		{
			this.SetInputElementsError()
			return false
		}
		bFound := false
		
		Loop, %length%
		{
			result := this.win.wb.Evaluate("document.getElementsByClassName('inDetailBox')[0].getElementsByTagName('IMG')[" A_Index - 1 "].alt")
			if (result.value = this.issued_company)
			{
				this.win.wb.Evaluate("document.getElementsByClassName('inDetailBox')[0].getElementsByTagName('IMG')[" A_Index - 1 "].click()")
				bFound := true
				break
			}
		}
		if (!bFound)
		{
			this.err := "입력페이지에서 " this.issued_company " 요소를 찾을수 없습니다."
			return false
		}
		if (this.issued_company = "기프티콘")
		{
			this.win.wb.Evaluate("document.getElementById('phoneNo').focus()")
			Sleep, 200
			Send, % this.codes[row][2]
			this.win.wb.Evaluate("document.getElementById('agreeThisOne').click()")
		}
		this.win.wb.Evaluate("document.getElementById('couponNo').focus()")
		this.SendExchange(row)
		this.win.wb.Evaluate("document.getElementById('couponRetrieve').click()")
		if (!_app.setting.ex_charging_auto)
		{
			return true
		}
		result := this.win.wb.Evaluate("escape(document.getElementsByClassName('payDetail excCoupon')[2].innerText)")  
		result_msg := this.win.Unescape(result.value)
		
		if (RegExMatch(result_msg, "가능합니다"))
		{
			charge_btnclass := _app.setting.ex_charging_target ? "hpOnlin" : "hpCash"
			this.win.wb.Evaluate("document.getElementsByClassName('" charge_btnclass "')[0].getElementsByTagName('A')[0].click()")
			result := this.win.wb.Evaluate("escape(document.getElementsByClassName('payDetail excCoupon')[2].innerText)")  
			result_msg := this.win.Unescape(result.value)
			if (RegExMatch(result_msg, "충전되었습니다|완료되었습니다"))
			{
				this.SetUsed(row)
				_app.editLog.AppendText(result_msg "`r`n")
				if (RegExMatch(result_msg, "O)([\d\-]{16,}).+([\d\-]{10})", matches))
				{
					_app.AddGiftCode("해피머니 상품권", matches[1] "-" StrReplace(matches[2], "-"))
				}
				return true
			}
			return this.ConfirmExchangeErrorGoNext(row)
		}
		else
		{
			return this.ConfirmExchangeErrorGoNext(row)
		}
		return false
	}
}
class CBookNLifeIE extends CBookNLife
{
	__New()
	{
		base.__New(0)
	}
	IsLogined()
	{
		elm := this.win.wb.document.getElementById("btn_logoutTOP")
		return (elm && elm.tagName)
	}
	AutoExchangeInput(row)
	{
		elements := this.win.wb.document.getElementsByClassName("tabList01 num04")
		if (!elements || elements.length < 1)
		{
			this.SetInputElementsError()
			return false
		}
		this.win.wb.document.getElementById("couponNum").focus()
		this.SendExchange(row)
		if (!_app.setting.ex_charging_auto)
		{
			return true
		}		
		index := _app.setting.ex_charging_target ? 1 : 0
		Sleep, 200
		this.win.wb.document.getElementsByClassName("btnArea")[0].getElementsByTagName("A")[index].click()
		if (!this.win.WaitComplete())
		{
			this.err := "충전 완료페이지로 이동에 실패했습니다"
			return false
		}
		result_msg := this.win.wb.document.getElementsByClassName("boardList")[0].innerText
		
		if (RegExMatch(result_msg, "O)쿠폰교환(.*)원[\d\-]+정상적으로", matches))
			{
			result := matches[1]
			if (index = 0)
			{
				success_msg := "북앤라이프 캐시 " result "원으로 정상적으로 교환되었습니다."
			}
			else
			{
				code := SubStr(result, 1, 19) "-" SubStr(result, 20, 4)
				success_msg := "북앤라이프 상품권 " code " 으로 정상적으로 교환되었습니다."
				_app.AddGiftCode("북앤라이프 상품권", code)
			}
			this.SetUsed(row)
			_app.AppendLog(success_msg)
			return true
		}
		else
		{
			return this.ConfirmExchangeErrorGoNext(row)
		}
		return false
	}
	AutoInput()
	{
		elements := this.win.wb.document.getElementsByClassName("btnLnit")
		if (!elements)
		{
			this.SetInputElementsError()
			return false
		}
		if (elements.length = 1)
		{
			elements[0].click()
			elements[0].scrollIntoView(true)
		}
		if (this.codes.MaxIndex() - this.page_base > 5)
		{
			elements := this.win.wb.document.getElementsByClassName("btnPlus")
			if (elements.length = 1)
			{
				Loop, % (this.codes.MaxIndex() - this.page_base - 5)
				{
					elements[0].click()
				}
			}
		}
		cols := Array()
		Loop, 4
		{
			cols[A_Index] := this.win.wb.document.getElementsByClassName("pinno" A_Index)
		}
		cols[5] := this.win.wb.document.getElementsByClassName("pincode")
		
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				cols[col][row - this.page_base -1].innerText := this.codes[row][col]
				this.Send(row, col, true)
			}
		}
		return true
	}
}
class CBookNLifeCR extends CBookNLife
{
	__New()
	{
		base.__New(1)
	}
	IsLogined()
	{
		result := this.win.wb.Evaluate("document.getElementById('btn_logoutTOP')")
		return (result.subtype != "null")
	}
	AutoExchangeInput(row)
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('tabList01 num04').length")
		if (result.value != 1)
		{
			this.SetInputElementsError()
			return false
		}
		this.win.wb.Evaluate("document.getElementById('couponNum').focus()")
		this.SendExchange(row)
		if (!_app.setting.ex_charging_auto)
		{
			return true
		}		
		index := _app.setting.ex_charging_target ? 1 : 0
		Sleep, 200
		
		this.win.wb.Evaluate("document.getElementsByClassName('btnArea')[0].getElementsByTagName('A')[" index "].click()")
		Sleep, 500
		if (!this.win.WaitComplete())
		{
			this.err := "충전 완료페이지로 이동에 실패했습니다"
			return false
		}
		result := this.win.wb.Evaluate("escape(document.getElementsByClassName('boardList')[0].innerText)")  
		result_msg := this.win.Unescape(result.value)
		;쿠폰교환	30,000원	2020-02-08	정상적으로 처리되었습니다.
		;쿠폰교환	1234-1234-1234-1234	1234	30,000원	2020-02-08	정상적으로 처리되었습니다.
		if (RegExMatch(result_msg, "O)쿠폰교환(.*)\s([\d\,]+)원.*정상적으로", matches))
		{
			pin := RegExReplace(matches[1], "[\s\-]")
			price := matches[2]
			if (StrLen(pin) = 0)
			{
				success_msg := "북앤라이프 캐시 " price "원으로 정상적으로 교환되었습니다."
			}
			else
			{
				if (StrLen(pin) = 20)
				{
					pin := SubStr(pin, 1, 4) "-" SubStr(pin, 5, 4) "-" SubStr(pin, 9, 4) "-" SubStr(pin, 13, 4) "-" SubStr(pin, 17, 4)
				}
				else
				{
				}
				success_msg := "북앤라이프 상품권 " pin " 으로 정상적으로 교환되었습니다."
				_app.AddGiftCode("북앤라이프 상품권", pin)
				
			}
			this.SetUsed(row)
			_app.AppendLog(success_msg)
			return true
		}
		else
		{
			return this.ConfirmExchangeErrorGoNext(row)
		}
		return false
	}	
	AutoInput()
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('btnLnit').length")
		if (result.value != 1)
		{
			this.SetInputElementsError()
			return false
		}
		
		this.win.wb.Evaluate("document.getElementsByClassName('btnLnit')[0].click()")
		this.win.wb.Evaluate("document.getElementsByClassName('btnLnit')[0].scrollIntoView(true)")
		
		if (this.codes.MaxIndex() - this.page_base > 5)
		{
			Loop, % (this.codes.MaxIndex() - this.page_base - 5)
			{
				this.win.wb.Evaluate("document.getElementsByClassName('btnPlus')[0].click()")
			}
		}
		
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				if (col = 5)
				{
					this.win.wb.Evaluate("document.getElementsByClassName('pincode')[" (row - this.page_base - 1) "].focus()")
				}
				else
				{
					this.win.wb.Evaluate("document.getElementsByClassName('pinno" col "')[" (row - this.page_base - 1)"].focus()")
				}
				this.Send(row, col)
			}
		}
		return true
	}
}
class CCultureLandIE extends CCultureLand
{
	__New()
	{
		base.__New(0)
	}
	IsLogined()
	{
		elm := this.win.wb.document.getElementsByClassName("cta login")
		return (elm && elm.length = 1)
	}
	AutoInput()
	{
		elements := this.win.wb.document.getElementsByClassName("stock-open")
		if (!elements || elements.length != 1)
		{
			this.SetInputElementsError()
			return false
		}
		if (this.codes.MaxIndex() - this.page_base > 5)
		{
			if (elements[0].style.display != "none")
			{
				elements[0].click()
			}
		}
		elements := this.win.wb.document.getElementsByClassName("sub-visual")
		if (elments && elements.length = 1)
		{
			elements[0].scrollIntoView(true)
			Sleep, 200
		}
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				eid := "scr" (row - this.page_base) col
				this.win.wb.document.getElementById(eid).click()
				this.Send(row, col)
			}
		}
		return true
	}
}
class CCultureLandCR extends CCultureLand
{
	__New()
	{
		base.__New(1)
	}
	IsLogined()
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('cta login').length")
		return (result.value = 1)
	}
	AutoInput()
	{
		result := this.win.wb.Evaluate("document.getElementsByClassName('stock-open').length")
		if (result.value != 1)
		{
			this.SetInputElementsError()
			return false
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('sub-visual')[0].scrollIntoView(true)")
		Sleep, 200
		if (this.codes.MaxIndex() - this.page_base> 5)
		{
			result := this.win.wb.Evaluate("document.getElementsByClassName('stock-open')[0].style.display")
			if (result.value != "none")
			{
				result := this.win.wb.Evaluate("document.getElementsByClassName('stock-open')[0].click()")
				Sleep, 500
			}
		}
		; autoTab2 끄기. 안끄면 Send로 보낸 4번째 숫자가 씹힘.
		disable_autotab := "function autoTab2(obj, className, event){}"
		result := this.win.wb.Evaluate(disable_autotab)
		Loop, % this.npp
		{
			row := A_Index + this.page_base
			if (row > this.codes.MaxIndex())
			{
				break
			}
			Loop, % this.codes[row].MaxIndex()
			{
				col := A_Index
				eid := "scr" (row - this.page_base) col
				this.win.wb.Evaluate("document.getElementById('" eid "').focus()")
				if ((row - this.page_base) = 1 && col = 1)
				{
					Sleep, 200
				}
				this.Send(row, col)
				Sleep, % _app.setting.send_interval
			}
		}
		return true
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Phone Message Readers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class CMessageReader
{
	__New(n)
	{
		this.name := n
		this.messages := []
		this.page := ""
		this.last := ""
		this.skip_pincheck := false
	}
	Init()
	{
		return true
	}
	SetCurrentPage(name)
	{
		this.page := "[ " name " ]"
	}
	Fetch()
	{
		return false
	}
	SkipPinCheck(bCheck)
	{
		this.skip_pincheck := bCheck
	}
	AddMessage(ByRef msg, prefix)
	{
		bFound := this.skip_pincheck 
		pos := 1
		while (!bFound && pos := RegExMatch(msg, "O)([\d\-\_ ]{12,})", matches, pos))
		{
			if (StrLen(RegExReplace(matches[1], "[^\d]")) >= 12)
			{
				bFound := true
				break
			}
			pos += matches.Len(0)
		}
		if (bFound)
		{
			o := Object()
			o.prefix := prefix ? prefix : this.last
			o.time := this.GetTime(o.prefix)
			o.msg := msg
			this.last := o.prefix
			this.messages.Push(o)
		}
	}
	Filter(time, regex)
	{
		arr := Array()
		Loop, % this.messages.MaxIndex()
		{
			if (time = 0 || time <= this.messages[A_Index].time)
			{
				if (!regex || RegExMatch(this.messages[A_Index].msg, regex))
				{
					arr.Push(this.messages[A_Index])
				}
			}
			else
			{
			}
		}
		this.messages := arr
	}
	GetTime(prefix)
	{
		return A_Now
	}
	GetLastMessage(ByRef msg, ByRef prefix)
	{
	}
}
class CMSYourPhoneMessageReader extends CMessageReader
{
	__New()
	{
		base.__New("사용자 휴대폰")
		this.uia := new CCUIAutomation()
		this.elm_msg := ""
	}
	Init()
	{
		if (!this.uia.pi)
		{
			this.err := "오류 : UI Automation 프레임워크를 사용할수 없습니다"
			return false
		}
		hWnd := WinExist("ahk_exe ApplicationFrameHost.exe")
		TreeScope_Children := 2
		CoreWindow_Pos := 1
		cond_true := this.uia.CreateTrueCondition()	
		phone := new CIUIAutomationElement(new CIUIAutomationElementArray(new CIUIAutomationElement(this.uia.ElementFromHandle(hWnd)).FindAll(TreeScope_Children, cond_true)).GetElement(CoreWindow_Pos))
		name := phone.CurrentName()
		if (name != "사용자 휴대폰")
		{
			this.err := this.name "의 화면을 찾을 수 없습니다."
			if (name)
			{
				this.err .= "현재 창 이름은 " name " 입니다"
			}
			return false
		}
		children := new CIUIAutomationElementArray(phone.FindAll(TreeScope_Children, cond_true))
		child := new CIUIAutomationElement(children.GetElement(0))
		if (child.CurrentName() = "기능")
		{
			children := new CIUIAutomationElementArray(child.FindAll(TreeScope_Children, cond_true))
		}
		UIA_ListControlTypeId	:=	50008
		Loop, % children.GetLength()
		{
			child := new CIUIAutomationElement(children.GetElement(A_Index -1))
			if (child.CurrentName() = "메시지" && child.CurrentControlType() = UIA_ListControlTypeId)
			{
				this.elm_msg := child
				if (this.elm_msg.pi)
				{
					return true
				}
				else
				{
					this.err := this.name "의 인터페이스를 가져오지 못했습니다"
					return false
				}
			}
		}
		this.err := this.name "의 메시지 창을 찾을수 없습니다"
		return false
	}
	Fetch()
	{
		TreeScope_Children := 2
		UIA_ScrollPatternId	:= 10004
		cond_true := this.uia.CreateTrueCondition()	
		scroll := new CIUIAutomationScrollPattern(this.elm_msg.GetControlPattern(UIA_ScrollPatternId))
		if (!scroll.pi)
		{
			this.err := "스크롤 패턴을 찾을수 없습니다"
			return false
		}
		v := scroll.CurrentVerticalViewSize()
		vpercent := 0
		msglist := Object()
		while (vpercent <= 100)
		{
			scroll.SetScrollPercent(-1,  vpercent)
			if (vpercent = 100 || v = 100)
			{
				vpercent := 101
			}
			else
			{
				vpercent += v
				if (vpercent > 100)
				{
					vpercent := 100
				}
			}
			Sleep, 100
			children := new CIUIAutomationElementArray(this.elm_msg.FindAll(TreeScope_Children, cond_true))
			Loop, % children.GetLength()
			{
				child := new CIUIAutomationElement(children.GetElement(A_Index -1))
				msg := child.CurrentName()
				bFound := false
				Loop, % msglist.MaxIndex()
				{
					if (msglist[A_Index] = msg)
					{
						bFound := true
						break
					}
				}
				if(!bFound)
				{
					msglist.Push(msg)
					if (RegExMatch(msg, "O)\. +([^\.]+)의 메시지", matches))
					{
						prefix := matches[1]
						msg := StrReplace(msg, matches[0])
						if (RegExMatch(msg, "O)^([^\.]+)\.", matches))
						{
							msg := StrReplace(msg, matches[0])
							prefix := matches[1] " : " prefix
							this.SetCurrentPage(matches[1])
						}
						this.AddMessage(msg, prefix)
					}							
				}
			}
		}
		return true
	}
	GetTime(prefix)
	{
		;[+82 1588-4763 : ‎2020‎-‎03‎-‎04 ‎오후‎ ‎9‎:‎50]
		if (RegExMatch(prefix, "O)([^ ]+) +([^ ]+) +([^ ]+)$", matches))
		{
			time := RegExReplace(matches[3], "[^\d]")
			if (Instr(matches[2], "오후"))
			{
				time += 1200
			}
			time := RegExReplace(matches[1], "[^\d]") . Format("{1:04d}", time) . "00"
			return time
		}
		else
		{
		}
		return A_Now
	}
	GetLastMessage(ByRef msg, ByRef prefix)
	{
		msg := "", prefix := ""
		TreeScope_Children := 2
		UIA_ScrollPatternId	:= 10004
		cond_true := this.uia.CreateTrueCondition()	
		scroll := new CIUIAutomationScrollPattern(this.elm_msg.GetControlPattern(UIA_ScrollPatternId))
		scroll.SetScrollPercent(-1,  100)
		children := new CIUIAutomationElementArray(this.elm_msg.FindAll(TreeScope_Children, cond_true))
		length := children.GetLength()
		if (length > 0)
		{
			child := new CIUIAutomationElement(children.GetElement(length -1))
			msg := child.CurrentName()
			if (RegExMatch(msg, "O)\. +([^\.]+)의 메시지", matches))
			{
				prefix := matches[1]
				msg := StrReplace(msg, matches[0])
				if (RegExMatch(msg, "O)^([^\.]+)\.", matches))
				{
					msg := StrReplace(msg, matches[0])
					prefix := matches[1] " : " prefix
				}

				return true
			}
			this.err := "메세지 시간정보를 찾을수 없습니다."
			return false
		}
		this.err := "메세지가 하나도 없습니다"
		return false
	}
}
class CChromeMessageReader extends CMessageReader
{
	__New(n, h)
	{
		base.__New(n)
		this.win := new CWBChrome(n, h)
	}
	Init()
	{
		if (this.win.Init() && this.win.CheckState())
		{
			this.win.Activate()
			this.win.Move(0, 0)
			return true
		}
		this.err := this.win.err
		return false
	}
}
class CGoogleMessageReader extends CChromeMessageReader
{
	__New()
	{
		base.__New("구글 메시지", "https://messages.google.com/web")
	}
	Init()
	{
		if (!base.Init())
		{
			return false
		}
		result := this.win.wb.Evaluate("escape(document.getElementsByClassName('title-container')[0].innerText)")
		if (!result.value)
		{
			this.err := this.name "에서 문자를 선택해 열어주세요"
			return false
		}
		this.SetCurrentPage(this.win.Unescape(result.value))
		return true
	}
	Fetch()
	{
		result := this.win.wb.Evaluate("document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children.length")
		if (result.value < 1)
		{
			this.err := "구성요소를 찾을수 없습니다. 문자가 열려있는지 확인해주세요"
			return false
		}
		prefix := ""
		Loop, % result.value
		{
			root_i := A_Index - 1
			result := this.win.wb.Evaluate("document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].tagName")
			if (result.value = "MWS-TOMBSTONE-MESSAGE-WRAPPER")
			{
				result := this.win.wb.Evaluate("escape(document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].innerText)")
				prefix := this.win.Unescape(result.value)
			}
			else if (result.value = "MWS-MESSAGE-WRAPPER")
			{
				result := this.win.wb.Evaluate("document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].getElementsByClassName('text-msg-content').length")
				if (result.value)
				{
					Loop, % result.value
					{
						result := this.win.wb.Evaluate("escape(document.getElementsByTagName('mws-tombstone-message-wrapper')[0].parentElement.children[" root_i "].getElementsByClassName('text-msg-content')[" A_Index - 1 "].innerText)")
						this.AddMessage(this.win.Unescape(result.value), prefix)
					}
				}
			}
		}
		return true
	}	
	GetTime(prefix)
	{
		static wdays := {"일요일" : 1 , "월요일" : 2, "화요일" : 3, "수요일" : 4, "목요일" : 5, "금요일" : 6, "토요일" : 7}
		if (RegExMatch(prefix, "O)(\d+년)?\s*(\d+월)?\s*(\d+일)?\s*([^ ]+요일)?.+(오전|오후) ([^ ]+)",matches))
		{
			year := matches[1] ? RegExReplace(matches[1], "[^\d]") : A_Year
			month := matches[2] ? Format("{1:02d}", RegExReplace(matches[2], "[^\d]")) : A_MM
			day := matches[3] ? Format("{1:02d}", RegExReplace(matches[3], "[^\d]")) : A_DD
			wday := matches[4] ? wdays[matches[4]] : A_Wday
			time := RegExReplace(matches[6], "[^\d]")
			if (matches[5] = "오후")
			{
				time += 1200
			}
			date := year month day Format("{1:04d}", time) "00"
			if (!matches[3])
			{
				day_before := wday - A_Wday
				if (day_before > 0)
				{
					day_before -= 7
				}
				date += %day_before%, D
			}
			return date
		}
		return A_Now
	}	
	GetLastMessage(ByRef msg, ByRef prefix)
	{
		msg := ""
		prefix := ""
		result := this.win.wb.Evaluate("document.getElementsByTagName('mws-relative-timestamp').length")
		if (result.value > 0)
		{
			result := this.win.wb.Evaluate("escape(document.getElementsByTagName('mws-relative-timestamp')[" (result.value - 1) "].innerText)")
			prefix := this.win.Unescape(result.value)
		}
		result := this.win.wb.Evaluate("document.getElementsByClassName('text-msg').length")
		if (result.value > 0)
		{
			result := this.win.wb.Evaluate("escape(document.getElementsByClassName('text-msg')[" (result.value - 1) "].innerText)")
			msg := this.win.Unescape(result.value)
			return true
		}
		return false
	}
}
class CPushbulletMessageReader extends CChromeMessageReader
{
	__New()
	{
		base.__New("Pushbullet", "https://www.pushbullet.com")
	}
	Init()
	{
		if (!base.Init())
		{
			return false
		}
		result := this.win.wb.Evaluate("document.getElementById('innerlist').children.length")
		if (result.value < 1)
		{
			this.err := this.name "에서 문자를 선택해 열어주세요"
			return false
		}
		return true
	}
	Fetch()
	{
		result := this.win.wb.Evaluate("document.getElementById('innerlist').children.length")
		if (result.value > 0)
		{
			length := result.value
			Loop, %length%
			{
				result := this.win.wb.Evaluate("document.getElementById('innerlist').children[" (A_Index - 1) "].children.length")
				if (result.value = 2)
				{
					result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" (A_Index - 1) "].children[0].innerText)")
					prefix := this.win.Unescape(result.value)
					result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" (A_Index - 1) "].children[1].innerText)")
					msg := this.win.Unescape(result.value)
				}
				else
				{
					result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" (A_Index - 1) "].innerText)")
					msg := this.win.Unescape(result.value)
				}
				this.AddMessage(msg, prefix)
			}
		}
		return true
	}
	GetTime(prefix)
	{
		static wdays := {"Sunday" : 1 , "Monday" : 2, "Tuesday" : 3, "Wednesday" : 4, "Thursday" : 5, "Friday" : 6, "Saturday" : 7, "Today" : A_Wday, "Yesterday" : A_Wday -1 }
		static today := A_Year A_MM A_DD
		;  02/07/2020 
		; [Last Monday at 9:21 PM]
		if (RegExMatch(prefix, "O)(\d{2})/(\d{2})/(\d{4})", matches))
		{
			return matches[3] matches[1] matches[2] "000000"
		}
		else if (RegExMatch(prefix, "O)([^ ]+) at ([^ ]+) ([AP]M)", matches))
		{
			time := RegExReplace(matches[2], "[^\d]")
			if (matches[3] = "PM")
			{
				time += 1200
			}
			date := today Format("{1:04d}", time)
			wday := wdays[matches[1]]
			day_before := wday - A_Wday
			if (day_before > 0)
			{
				day_before -= 7
			}
			date += %day_before%, D
			return date
		}
		return A_Now
	}
	GetLastMessage(ByRef msg, ByRef prefix)
	{
		result := this.win.wb.Evaluate("document.getElementById('innerlist').children.length")
		if (result.value > 0)
		{
			index := result.value - 1
			result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" index "].children[0].innerText)")
			prefix := this.win.Unescape(result.value)
			result := this.win.wb.Evaluate("escape(document.getElementById('innerlist').children[" index "].children[1].innerText)")
			msg := this.win.Unescape(result.value)
			return true
		}
		return false
	}
}
class CKakaoTalkMessageReader extends CMessageReader
{
	__New()
	{
		base.__New("카카오톡")
		this.win := ""
	}
	Init()
	{
		WinGet, windows, List
		Loop, %windows%
		{
			win := new CWindow(windows%A_Index%)
			if (win.GetClass() = "#32770" && win.GetProcessName() = "KakaoTalk.exe")
			{
				win.Activate()
				this.SetCurrentPage(win.GetTitle()) 
				this.win := new CWindow(win.ControlGet("EVA_VH_ListControl_Dblclk1"))
				if (this.win.Exist())
				{
					return true
				}
				this.err .= "카카오톡 대화창이 아닙니다"
				return false
			}
		}
		this.err := this.name " 대화창을 찾을수 없습니다"
		return false
	}
	Fetch()
	{
		; 전체선택
		this.win.SendMessage(0x07E9, 0x65, 0)
		; 복사
		this.win.SendMessage(0x07E9, 0x64, 0)
		txt := Clipboard
		arr_daily := Array()
		arr_daily_date := Array()
		pos := 1
		while (pos := RegExMatch(txt, "Om)^(\d{4}년.*요일)$", matches, pos))
		{
			arr_daily.Push(pos)
			arr_daily_date.Push(matches[1])
			pos += matches.Len(0)
		}
		Loop, % arr_daily.MaxIndex()
		{
			daily_date := arr_daily_date[A_Index]
			pos_start := arr_daily[A_Index] + StrLen(daily_date) + 2
			if (A_Index = arr_daily.MaxIndex())
			{
				daily_msg := SubStr(txt, pos_start)
			}
			else
			{
				daily_msg := Substr(txt, pos_start, arr_daily[A_Index +1] - pos_start)
			}
			arr_msg := Array()
			arr_msg_prefix := Array()
			arr_msg_datetime := Array()
			pos := 1
			while (pos := RegExMatch(daily_msg, "Om)^\[[^\]]+\]\s+\[(오. [\d\:]+)\] ", matches, pos))
			{
				arr_msg.Push(pos)
				arr_msg_prefix.Push(matches[0])
				arr_msg_datetime.Push(matches[1])
				pos += matches.Len(0)
			}
			Loop, % arr_msg.MaxIndex()
			{
				msg_date := daily_date " " arr_msg_datetime[A_Index]
				pos_start := arr_msg[A_Index] + StrLen(arr_msg_prefix[A_Index])
				if (A_Index = arr_msg.MaxIndex())
				{
					msg := SubStr(daily_msg, pos_start)
				}
				else
				{
					msg := Substr(daily_msg, pos_start, arr_msg[A_Index +1] - pos_start - 2)
				}
				this.AddMessage(msg, msg_date)
			}
		}
		return true
	}
	GetTime(prefix)
	{
		;[2020년 3월 4일 수요일 오전 10:28]
		if (RegExMatch(prefix, "O)(\d{4})년 (\d+)월 (\d+)일(.+)", matches))
		{
			time := RegExReplace(matches[4], "[^\d]")
			if (InStr(matches[4], "오후"))
			{
				time += 1200
			}
			return matches[1] . Format("{1:02d}", matches[2]) . Format("{1:02d}", matches[3]) .  Format("{1:04d}", time) . "00"
		}
		return A_Now
	}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 이하는 외부의 공개 WBGet함수, JSON 라이브러리 코드입니다. 
;; 자동입력기를 하나의 파일로 배포하기 위해 따로 Include하지 않고 
;; 원본소스에서 주석, 공백제거한후 코드에 이어 삽입했습니다.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; [WBGet function for AHK v1.1]
; WBGet function - AutoHotkey Community
; https://autohotkey.com/boards/viewtopic.php?f=6&t=39869
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WBGet(WinTitle="ahk_class IEFrame", Svr#=1) {               ;// based on ComObjQuery docs
   static msg := DllCall("RegisterWindowMessage", "str", "WM_HTML_GETOBJECT")
        , IID := "{0002DF05-0000-0000-C000-000000000046}"   ;// IID_IWebBrowserApp
;//     , IID := "{332C4427-26CB-11D0-B483-00C04FD90119}"   ;// IID_IHTMLWindow2
   SendMessage msg, 0, 0, Internet Explorer_Server%Svr#%, %WinTitle%
   if (ErrorLevel != "FAIL") {
      lResult:=ErrorLevel, VarSetCapacity(GUID,16,0)
      if DllCall("ole32\CLSIDFromString", "wstr","{332C4425-26CB-11D0-B483-00C04FD90119}", "ptr",&GUID) >= 0 {
         DllCall("oleacc\ObjectFromLresult", "ptr",lResult, "ptr",&GUID, "ptr",0, "ptr*",pdoc)
         return ComObj(9,ComObjQuery(pdoc,IID,IID),1), ObjRelease(pdoc)
      }
   }
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; JSON lib for AutoHotkey v2.1.3 [updated 04/18/2016 (MM/DD/YYYY)]
; 배포사이트 : https://github.com/cocobelgica/AutoHotkey-JSON
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
class JSON
{
class Load extends JSON.Functor
{
Call(self, ByRef text, reviver:="")
{
this.rev := IsObject(reviver) ? reviver : false
this.keys := this.rev ? {} : false
static quot := Chr(34), bashq := "\" . quot
, json_value := quot . "{[01234567890-tfn"
, json_value_or_array_closing := quot . "{[]01234567890-tfn"
, object_key_or_object_closing := quot . "}"
key := ""
is_key := false
root := {}
stack := [root]
next := json_value
pos := 0
while ((ch := SubStr(text, ++pos, 1)) != "") {
if InStr(" `t`r`n", ch)
continue
if !InStr(next, ch, 1)
this.ParseError(next, text, pos)
holder := stack[1]
is_array := holder.IsArray
if InStr(",:", ch) {
next := (is_key := !is_array && ch == ",") ? quot : json_value
} else if InStr("}]", ch) {
ObjRemoveAt(stack, 1)
next := stack[1]==root ? "" : stack[1].IsArray ? ",]" : ",}"
} else {
if InStr("{[", ch) {
static json_array := Func("Array").IsBuiltIn || ![].IsArray ? {IsArray: true} : 0
(ch == "{")
? ( is_key := true
, value := {}
, next := object_key_or_object_closing )
: ( value := json_array ? new json_array : []
, next := json_value_or_array_closing )
ObjInsertAt(stack, 1, value)
if (this.keys)
this.keys[value] := []
} else {
if (ch == quot) {
i := pos
while (i := InStr(text, quot,, i+1)) {
value := StrReplace(SubStr(text, pos+1, i-pos-1), "\\", "\u005c")
static tail := A_AhkVersion<"2" ? 0 : -1
if (SubStr(value, tail) != "\")
break
}if (!i)
this.ParseError("'", text, pos)
  value := StrReplace(value,  "\/",  "/")
, value := StrReplace(value, bashq, quot)
, value := StrReplace(value,  "\b", "`b")
, value := StrReplace(value,  "\f", "`f")
, value := StrReplace(value,  "\n", "`n")
, value := StrReplace(value,  "\r", "`r")
, value := StrReplace(value,  "", "`t")
pos := i
i := 0
while (i := InStr(value, "\",, i+1)) {
if !(SubStr(value, i+1, 1) == "u")
this.ParseError("\", text, pos - StrLen(SubStr(value, i+1)))
uffff := Abs("0x" . SubStr(value, i+2, 4))
if (A_IsUnicode || uffff < 0x100)
value := SubStr(value, 1, i-1) . Chr(uffff) . SubStr(value, i+6)
}if (is_key) {
key := value, next := ":"
continue
}} else {
value := SubStr(text, pos, i := RegExMatch(text, "[\]\},\s]|$",, pos)-pos)
static number := "number", integer :="integer"
if value is %number%
{
if value is %integer%
value += 0
}else if (value == "true" || value == "false")
value := %value% + 0
else if (value == "null")
value := ""
else
this.ParseError(next, text, pos, i)
pos += i-1
}next := holder==root ? "" : is_array ? ",]" : ",}"
}is_array? key := ObjPush(holder, value) : holder[key] := value
if (this.keys && this.keys.HasKey(holder))
this.keys[holder].Push(key)
}}
return this.rev ? this.Walk(root, "") : root[""]
}ParseError(expect, ByRef text, pos, len:=1)
{
static quot := Chr(34), qurly := quot . "}"
line := StrSplit(SubStr(text, 1, pos), "`n", "`r").Length()
col := pos - InStr(text, "`n",, -(StrLen(text)-pos+1))
msg := Format("{1}`n`nLine:`t{2}`nCol:`t{3}`nChar:`t{4}"
,     (expect == "")     ? "Extra data"
: (expect == "'")    ? "Unterminated string starting at"
: (expect == "\")    ? "Invalid \escape"
: (expect == ":")    ? "Expecting ':' delimiter"
: (expect == quot)   ? "Expecting object key enclosed in double quotes"
: (expect == qurly)  ? "Expecting object key enclosed in double quotes or object closing '}'"
: (expect == ",}")   ? "Expecting ',' delimiter or object closing '}'"
: (expect == ",]")   ? "Expecting ',' delimiter or array closing ']'"
: InStr(expect, "]") ? "Expecting JSON value or array closing ']'"
:                      "Expecting JSON value(string, number, true, false, null, object or array)"
, line, col, pos)
static offset := A_AhkVersion<"2" ? -3 : -4
throw Exception(msg, offset, SubStr(text, pos, len))
}Walk(holder, key)
{
value := holder[key]
if IsObject(value) {
for i, k in this.keys[value] {
v := this.Walk(value, k)
if (v != JSON.Undefined)
value[k] := v
else
ObjDelete(value, k)
}}
return this.rev.Call(holder, key, value)
}}
class Dump extends JSON.Functor
{
Call(self, value, replacer:="", space:="")
{
this.rep := IsObject(replacer) ? replacer : ""
this.gap := ""
if (space) {
static integer := "integer"
if space is %integer%
Loop, % ((n := Abs(space))>10 ? 10 : n)
this.gap .= " "
else
this.gap := SubStr(space, 1, 10)
this.indent := "`n"
}return this.Str({"": value}, "")
}Str(holder, key)
{
value := holder[key]
if (this.rep)
value := this.rep.Call(holder, key, ObjHasKey(holder, key) ? value : JSON.Undefined)
if IsObject(value) {
static type := A_AhkVersion<"2" ? "" : Func("Type")
if (type ? type.Call(value) == "Object" : ObjGetCapacity(value) != "") {
if (this.gap) {
stepback := this.indent
this.indent .= this.gap
}is_array := value.IsArray
if (!is_array) {
for i in value
is_array := i == A_Index
until !is_array
}str := ""
if (is_array) {
Loop, % value.Length() {
if (this.gap)
str .= this.indent
v := this.Str(value, A_Index)
str .= (v != "") ? v . "," : "null,"
}} else {
colon := this.gap ? ": " : ":"
for k in value {
v := this.Str(value, k)
if (v != "") {
if (this.gap)
str .= this.indent
str .= this.Quote(k) . colon . v . ","
}}
}if (str != "") {
str := RTrim(str, ",")
if (this.gap)
str .= stepback
}if (this.gap)
this.indent := stepback
return is_array ? "[" . str . "]" : "{" . str . "}"
}} else
return ObjGetCapacity([value], 1)=="" ? value : this.Quote(value)
}Quote(string)
{
static quot := Chr(34), bashq := "\" . quot
if (string != "") {
  string := StrReplace(string,  "\",  "\\")
, string := StrReplace(string, quot, bashq)
, string := StrReplace(string, "`b",  "\b")
, string := StrReplace(string, "`f",  "\f")
, string := StrReplace(string, "`n",  "\n")
, string := StrReplace(string, "`r",  "\r")
, string := StrReplace(string, "`t",  "")
static rx_escapable := A_AhkVersion<"2" ? "O)[^\x20-\x7e]" : "[^\x20-\x7e]"
while RegExMatch(string, rx_escapable, m)
string := StrReplace(string, m.Value, Format("\u{1:04x}", Ord(m.Value)))
}return quot . string . quot
}}
Undefined[]
{
get {
static empty := {}, vt_empty := ComObject(0, &empty, 1)
return vt_empty
}}
class Functor
{
__Call(method, ByRef arg, args*)
{
if IsObject(method)
return (new this).Call(method, arg, args*)
else if (method == "")
return (new this).Call(arg, args*)
}}
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
